<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@page contentType="text/html" pageEncoding="UTF-8" import="java.util.*"%>
<%@ page import="org.wso2.carbon.endpoint.service.EndpointAdminStub" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.*" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.*" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="java.io.*" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.apache.axiom.om.OMAttribute" %>
<%@ page import="javax.xml.namespace.QName" %>

<%
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
            session);

    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient client = new EndpointAdminClient(cookie, url, configContext);

    OMElement elem = null;
    String payload = request.getParameter("xmlpayload");
    String forwardTo = "";
    boolean error = false;
    try{
        elem = EndpointAdminClient.createOMFromString(payload);
        OMAttribute nameAttr = elem.getAttribute(new QName("name"));
        String epMode;
        if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
            // we are in the anon mode
            if (nameAttr != null) {
                elem.removeAttribute(nameAttr);
            }
            session.setAttribute("anonEpXML", elem.toString());
            forwardTo = (String) session.getAttribute("anonOriginator") + "?originator=addEpSrcSaveHelper.jsp";
        } else {
            forwardTo = "index.jsp";
            String epName = null;
            if(nameAttr!=null){
                epName = nameAttr.getAttributeValue();

//                EndpointMetaData[] epMetaData = client.getEndpointMetaData();
//                boolean exists = false;
//
//                if (epMetaData != null) {
//                    for (EndpointMetaData data : epMetaData) {
//                        if (data.getName().equalsIgnoreCase(epName)) {
//                            exists = true;
//                            break;
//                        }
//                    }
//                }
                if (client.isEndpointExist(epName)) {
                    try {
                        client.saveEndpoint(payload);
                    } catch (Exception e) {
                        error = true;
                        String forwardPageName = (String)session.getAttribute("savePage");
                        session.removeAttribute("savePage");
                        String errMsg = e.getMessage();
                        String dspMsg = errMsg.replaceAll("\\'","");
                        %>    <script type="text/javascript">
                             jQuery(document).ready(function(){
                            function gotoPage(){
                               // document.location.href='<%=forwardPageName%>';
                                history.go(-1);
                            }
                            CARBON.showErrorDialog('<%=dspMsg%>',gotoPage);
                                  });
                        </script>
                        <%
                    }
                } else {
                    try {
                        client.addEndpoint(payload);
                    } catch (Exception e) {
                        error = true;
                        String errMsg = e.getMessage();
                        String dspMsg = errMsg.replaceAll("\\'","");
                        String forwardPageName = (String)session.getAttribute("savePage");
                        session.removeAttribute("savePage");
                        %><script type="text/javascript">

                            jQuery(document).ready(function(){
                               function gotoPage(){
                              //  document.location.href='<%=forwardPageName%>';
                                   history.go(-1);
                            }
                               CARBON.showErrorDialog('<%=dspMsg%>',gotoPage);
                            });


                        </script>
                        <%
                    }
                }
            }
        }

    } catch(XMLStreamException e){%>
        <script type="text/javascript">
            CARBON.showErrorDialog("Unable to parse the endpoint XML");
            window.location.href="AddressEndpoint.jsp";
        </script>
        <% return;
    }%>

<%if(!error){%>
<script type="text/javascript">
    window.location.href='<%=forwardTo%>';
</script>
<%}%>