<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@page contentType="text/html" pageEncoding="UTF-8" import="java.util.*"%>
<%@ page import="org.wso2.carbon.endpoint.service.EndpointAdminStub" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.*" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.*" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="java.io.*" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axiom.om.impl.builder.StAXOMBuilder" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.apache.axiom.om.OMAttribute" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">


<div>
<%!private static final String SYNAPSE_NS = "http://ws.apache.org/ns/synapse";
    private HttpServletRequest req = null;
    private static final String gt = ">";
    private static final String lt = "<";
%>


<script type="text/javascript">
    function forward(){
        location.href="index.jsp";
    }

    function forwardDesign(ep){
        location.href="AddressEndpoint.jsp?endpointName="+ep;
    }

    function errorPageForward(msg){
        location.href="../admin/error.jsp?"+msg;
    }
</script>

<%!
    private boolean errorCodesValidator(String errCodes){
        String [] errorCodes = errCodes.split(",");
        for(int i=0;i<errorCodes.length;i++){
            try{
                 int iErrChecker = Integer.parseInt(errorCodes[i]);
            }
            catch(NumberFormatException e){
                return false;
            }
        }
        return true;
    }

    private String getAddressEndpointXML(boolean anon)throws Exception{
    String name = req.getParameter("Name");
    String address = req.getParameter("Address");
    String format = req.getParameter("Format");
    String optimize = req.getParameter("Optimize");
    String susDuration = null;
    if(!(req.getParameter("DurationSec")==null)){
        susDuration = req.getParameter("DurationSec");
    }
    String timeOutAction = req.getParameter("Action");
    String actionDurSec = req.getParameter("DurationInAction");
    String wsAddEnable = req.getParameter("wsAddEnable");
    String sepListener = req.getParameter("sepLis");
    String wsSecEnable = req.getParameter("wsSec");
    String wsRmEnable = req.getParameter("wsRm");
    String errorCodes = req.getParameter("errCodes");
    String maxDur = req.getParameter("maxDur");
    String factor = req.getParameter("factor");
    String retryDelay = req.getParameter("retryDelay");
    String retry = req.getParameter("retry");
    String timeoutErrCodes = req.getParameter("timoutErr");
    String secPolKey = req.getParameter("polKey");
    String rmPolKey = req.getParameter("rmpolKey");

    StringBuilder addXML = new StringBuilder();
    addXML.append(lt+"syn:endpoint xmlns:syn=\""+SYNAPSE_NS+"\"");
    if (anon) {
        addXML.append(gt);
    } else {
        addXML.append(" name=\""+name.trim()+"\""+gt);
    }
    addXML.append(lt+"syn:address uri=\""+address);
    addXML.append("\"");

    if(format!=null){
        if(!(format.equalsIgnoreCase("Leave As-Is"))){
            addXML.append(" format=\"");
            if(format.contains("SOAP 1.1")){
                addXML.append("soap11");
            }
            else if(format.contains("SOAP 1.2")){
                addXML.append("soap12");
            }
            else if(format.contains("Plain Old XML (POX)")){
                addXML.append("pox");
            }
            else{
                addXML.append("get");
            }
            addXML.append("\"");
        }
    }

    if(optimize!=null){

        if(!(optimize.equalsIgnoreCase("Leave As-Is"))){
            addXML.append(" optimize=\"");
            if(optimize.equalsIgnoreCase("SwA")){
                addXML.append("swa");
            }
            else{
                addXML.append("mtom");
            }
            addXML.append("\"");
        }

    }
    addXML.append(" "+gt);
    String susXML = null;
    //put a javascript to check if value entered is a number
    if(!(susDuration.equalsIgnoreCase(""))){
        if(Integer.valueOf(susDuration) >0){
            susXML = "<syn:suspendOnFailure><syn:initialDuration>"+ Long.valueOf(susDuration.trim())+"</syn:initialDuration>";

        }
    }

    if(!(errorCodes.equalsIgnoreCase(""))){
        if(errorCodesValidator(errorCodes)){
        if(susXML==null){
            susXML = "<syn:suspendOnFailure>"+"<syn:errorCodes>"+ errorCodes.trim()+ "</syn:errorCodes>";
        }
        else{
            susXML += "<syn:errorCodes>"+ errorCodes.trim()+ "</syn:errorCodes>";
        }
        }
        else{
            throw new Exception("Error Codes are invalid, Please enter only numeric values");
        }
    }


    if(susXML!=null){

        if(!(maxDur.equalsIgnoreCase(""))){
            susXML += "<syn:maximumDuration>"+ Long.valueOf(maxDur)+"</syn:maximumDuration>";
        }
        if(!(factor.equalsIgnoreCase(""))){
            susXML += "<syn:progressionFactor>"+ Float.valueOf(factor)+"</syn:progressionFactor>";
        }
        else{
            susXML += "<syn:progressionFactor>"+"0.0"+"</syn:progressionFactor>";
        }
        susXML+= "</syn:suspendOnFailure>";
        addXML.append(susXML);
    }

   String timedoutXML = null;
    if(!(retry.equalsIgnoreCase(""))){
        if(Integer.valueOf(retryDelay).intValue()>0){
            timedoutXML += "<syn:markForSuspension><syn:retryDelay>"+retry+"</syn:retryDelay>";
        }
    }

    if(!(timeoutErrCodes.equalsIgnoreCase(""))){
        if(errorCodesValidator(timeoutErrCodes)){
        if(timedoutXML==null){
            timedoutXML ="<syn:markForSuspension><syn:errorCodes>"+timeoutErrCodes+"</syn:errorCodes>";
        }
        else{
            timedoutXML +="<syn:errorCodes>"+timeoutErrCodes+"</syn:errorCodes>";
        }
        }
        else{
            throw new Exception("Error Codes are invalid, Please enter only numeric values");
        }


    }


    if(timedoutXML!=null){
        
        if(!(retryDelay.equalsIgnoreCase(""))){
            timedoutXML +="<syn:retriesBeforeSuspension>"+retryDelay+"</syn:retriesBeforeSuspension>";

        }
        timedoutXML += "</syn:markForSuspension>";
        addXML.append(timedoutXML);
    }

    if(wsAddEnable!=null && wsAddEnable.equalsIgnoreCase("checked")){

        if(sepListener!=null && sepListener.equalsIgnoreCase("checked")){
            addXML.append(lt+"syn:enableAddressing separateListener='true'/"+gt)  ;
        }
        else{
            addXML.append(lt+"syn:enableAddressing/"+gt);
        }
    }

    if(timeOutAction!=null && (!(timeOutAction.equalsIgnoreCase("Never timeout")))){

        addXML.append(lt+"syn:timeout"+gt+" ");
        addXML.append(lt+"syn:action"+gt+" ");
        if(timeOutAction.equalsIgnoreCase("Discard message")){
            addXML.append("discard");
        }
        else{
            addXML.append("fault");
        }
        addXML.append(lt+"/syn:action"+gt+" ");

        if(actionDurSec!=null){
            addXML.append(lt+"syn:duration"+gt+Long.valueOf(actionDurSec.trim())+lt+"/syn:duration"+gt+" ");
        }

        addXML.append(lt+"/syn:timeout"+gt);
    }
    if(wsRmEnable!=null && (wsRmEnable.equalsIgnoreCase("checked"))){
                if(rmPolKey==null){
                addXML.append("<syn:enableRM/>");
                }
                else {
                    addXML.append("<syn:enableRM ");
                    addXML.append("policy=\""+rmPolKey+"\"");
                    addXML.append("></syn:enableRM>");
                }
            }
            if(wsSecEnable!=null && wsSecEnable.equalsIgnoreCase("checked")){
                if(secPolKey==null){
                addXML.append("<syn:enableSec/>");
                }
                 else {
                    addXML.append("<syn:enableSec ");
                    addXML.append("policy=\""+secPolKey+"\"");
                    addXML.append("></syn:enableSec>");
                }
            }

    addXML.append(lt+"/syn:address"+gt);
    addXML.append(lt+"/syn:endpoint"+gt);
    return addXML.toString().trim();
}
%>

<%
    req = request;
    String name = request.getParameter("Name");
    String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
            session);

    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    EndpointAdminClient client = new EndpointAdminClient(cookie, url, configContext);

    boolean error = false;
    String sub = null;
    StringBuilder ss = new StringBuilder();
    try{
    ss.append(getAddressEndpointXML("anon".equals(session.getAttribute("epMode"))));
    }
    catch(Exception e){
        %>
          <script type="text/javascript">
    jQuery(document).ready(function(){
    function gotoPage(){
        //document.location.href='AddressEndpoint.jsp';
        history.go(-1);
    }
    CARBON.showErrorDialog('<%=e.getMessage()%>',gotoPage);
        });
</script>
    <%
   break;
        }
    // checks whether we are in anonymous endpoint mode
    String epMode = (String)session.getAttribute("epMode");
    if (epMode != null && !"".equals(epMode) && "anon".equals(epMode)) {
        String forwardTo = (String)session.getAttribute("anonOriginator") + "?originator=AddressEndpointCaller.jsp";
        try {
            EndpointAdminClient.getAddressEndpointData(ss.toString());
            session.setAttribute("anonEpXML", ss.toString());
        } catch (Exception e) {
            forwardTo = "AddressEndpoint.jsp";%>
            <script type="text/javascript">
                CARBON.showErrorDialog("Unable to create endpoint with given data");
            </script><%
        }%>
        <script type="text/javascript">
            window.location.href="<%=forwardTo%>";
        </script><%
} else {
    EndpointMetaData[] epMetaData = client.getEndpointMetaData();
    boolean exists = false;
    if (epMetaData != null) {
        for (EndpointMetaData data : epMetaData) {
            if (data.getName().equalsIgnoreCase(name)) {
                exists = true;
                break;
            }
        }
    }
    if (exists && ((session.getAttribute("edit" + name)) != null)) {
        try {
            client.saveEndpoint(ss.toString());
            session.removeAttribute("edit"+name);
        }
        catch (Exception e) {
            session.removeAttribute("edit"+name);
            error = true;
            String errMsg = e.getMessage();
            String dspMsg = errMsg.replaceAll("\\'","");
%>
<script type="text/javascript">
    jQuery(document).ready(function(){
    function gotoPage(){
       // document.location.href='AddressEndpoint.jsp';
        history.go(-1);
    }                                                      
    CARBON.showErrorDialog('<%=dspMsg%>',gotoPage);
          });
</script>
<%
    }
} else {
        try {
            client.addEndpoint(ss.toString());
        } catch (Exception e) {
            error = true;
            String errMsg = e.getMessage();
            String dspMsg = errMsg.replaceAll("\\'","");
%>
<script type="text/javascript">
    jQuery(document).ready(function(){
    function gotoPage(){
        //document.location.href='AddressEndpoint.jsp';
        history.go(-1);
    }
    CARBON.showErrorDialog('<%=dspMsg%>',gotoPage);
        });
</script>
<%
            }
        }
    }
%>
<%if(sub!=null){%>
<script type="text/javascript">
    forwardDesign('<%=sub%>');
</script>
<%}else{%>
<%if(!error){%>
<script type="text/javascript">
    forward();
</script>
<%}}%>
</div>
</fmt:bundle>