<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ page import="org.apache.synapse.config.xml.endpoints.*" %>
<%@ page import="org.apache.synapse.endpoints.*" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.AddressEndpointData" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.WSDLEndpointData" %>
<%@ page import="java.util.List" %>

<%!
    private AddressEndpointData getAddressEpFromSynEp(AddressEndpoint add, HttpSession session){
        AddressEndpointData data  = new AddressEndpointData();
        // assigns no name if epMode is anon
        String epMode;
        if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
            data.setEpName("");
        } else {
            data.setEpName(add.getName());
        }
        data.setAddress(add.getDefinition().getAddress());
        data.setEpType(0);
        //data.setFormat(add.getDefinition().getFormat());
        data.setSoap11(add.getDefinition().isForceSOAP11());
        data.setSoap12(add.getDefinition().isForceSOAP12());
        data.setRest(add.getDefinition().isForceGET());
        data.setPox(add.getDefinition().isForcePOX());
        data.setSwa(add.getDefinition().isUseSwa());
        data.setMtom(add.getDefinition().isUseMTOM());
        data.setSuspendDurationOnFailure(add.getDefinition().getInitialSuspendDuration());
        data.setTimeoutAct(add.getDefinition().getTimeoutAction());
        data.setTimeoutActionDur(add.getDefinition().getTimeoutDuration());
        data.setWsadd(add.getDefinition().isAddressingOn());
        data.setSepList(add.getDefinition().isUseSeparateListener());
        data.setWssec(add.getDefinition().isSecurityOn());
        data.setWsrm(add.getDefinition().isReliableMessagingOn());
        data.setRmPolKey(add.getDefinition().getWsRMPolicyKey());
        data.setSecPolKey(add.getDefinition().getWsSecPolicyKey());
        data.setMaxSusDuration(add.getDefinition().getSuspendMaximumDuration());
        data.setSusProgFactor(add.getDefinition().getSuspendProgressionFactor());
        data.setErrorCodes(errorCodeListBuilder(add.getDefinition().getSuspendErrorCodes()).trim());
        data.setTimdedOutErrorCodes(errorCodeListBuilder(add.getDefinition().getTimeoutErrorCodes()));
        data.setRetryTimeout(add.getDefinition().getRetryDurationOnTimeout());
        data.setRetryDelay(add.getDefinition().getRetriesOnTimeoutBeforeSuspend());
        return data;
    }
    private String errorCodeListBuilder(List<Integer> errCodes){
        String errorCodes = " ";
        for (Integer errCode : errCodes) {
            errorCodes += errCode;
            errorCodes += ",";
        }
        return errorCodes.substring(0,errorCodes.length()-1);
    }

    private WSDLEndpointData getWSDLEpFromSynEp(WSDLEndpoint wsdlEp, HttpSession session){
        WSDLEndpointData data = new WSDLEndpointData();
        // assigns no name if epMode is anon
        String epMode;
        if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
            data.setEpName("");
        } else {
            data.setEpName(wsdlEp.getName());
        }
        data.setEpUri(wsdlEp.getWsdlURI());
        data.setEpServ(wsdlEp.getServiceName());
        data.setEpPort(wsdlEp.getPortName());
        data.setEpType(1);
        data.setEpDur(wsdlEp.getDefinition().getInitialSuspendDuration());

        data.setEpwsdlTimeoutAction(wsdlEp.getDefinition().getTimeoutAction());

        data.setEpactionDuration(wsdlEp.getDefinition().getTimeoutDuration());
        data.setEpaddressingOn(wsdlEp.getDefinition().isAddressingOn());

        data.setEpsecutiryOn(wsdlEp.getDefinition().isSecurityOn());
        data.setEpwsaddSepListener(wsdlEp.getDefinition().isUseSeparateListener());

        data.setEprelMesg(wsdlEp.getDefinition().isReliableMessagingOn());
        data.setEpwsdlSecutiryKey(wsdlEp.getDefinition().getWsSecPolicyKey());
        data.setEprmKey(wsdlEp.getDefinition().getWsRMPolicyKey());

        data.setEperrorCodes(errorCodeListBuilder(wsdlEp.getDefinition().getSuspendErrorCodes()));
        data.setEpmaxSusDuration(wsdlEp.getDefinition().getSuspendMaximumDuration());
        data.setEpsusProgFactor(wsdlEp.getDefinition().getSuspendProgressionFactor());


        data.setEptimdedOutErrorCodes(errorCodeListBuilder(wsdlEp.getDefinition().getTimeoutErrorCodes()));
        data.setEpretryTimeout(wsdlEp.getDefinition().getRetryDurationOnTimeout());
        data.setEpretryDelay(wsdlEp.getDefinition().getRetriesOnTimeoutBeforeSuspend());

        if(wsdlEp.getWsdlDoc()!=null){
            data.setInLineWSDL(wsdlEp.getWsdlDoc().toString());
        }

        return data;
    }

%>

<%
    String payload = request.getParameter("xmlpayload");
    String pageType = (String)session.getAttribute("page");

    //out.println(payload);

    OMElement ele = null;
    AddressEndpointData epData = null;
    try{
        ele = AXIOMUtil.stringToOM(payload);
        // if epMode is anon then sets a dummy name (i.e. anonymous) in order to retrieve an endpoint object from the factory
        String epMode;
        if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
            ele.addAttribute("name", "anonymous", ele.getOMFactory().createOMNamespace("",""));
        }
        if(pageType.equalsIgnoreCase("address")){
            AddressEndpoint ep = (AddressEndpoint)EndpointFactory.getEndpointFromElement(ele,false);
            //out.println(ep.getName());
            epData = getAddressEpFromSynEp(ep, session);
            session.setAttribute("design",epData);
        }
        else{
            WSDLEndpointData wsdlData;
            WSDLEndpoint ep = (WSDLEndpoint)EndpointFactory.getEndpointFromElement(ele,false);
            //out.println(ep.getName());
            wsdlData = getWSDLEpFromSynEp(ep, session);
            session.setAttribute("design",wsdlData);
        }
        session.removeAttribute("page");
    }
    catch(XMLStreamException e){
        
    }
    catch(Exception e){
        
    }

%>
<%--<jsp:forward page="AddressEndpoint.jsp"/>   --%>
<%if(pageType.equalsIgnoreCase("address")){%>
<script type="text/javascript">
    location.href="AddressEndpoint.jsp?ordinal=1";
  </script>
<%}else{%>
<script type="text/javascript">
    location.href="wsdlEndpoint.jsp?ordinal=1";
  </script>
<%}%>