function initDoc(){
	if (doc == null) {
	
	    if(payload == "null"){
	        doc = newXML();
	        var rootElm = doc.createElement("syn:endpoint");
	        rootElm.setAttribute("xmlns:syn","http://ws.apache.org/ns/synapse");
	       // rootElm.setAttribute("name","d1");
	       var rootFailover;
	       if(mainType == "load"){
	       		rootFailover = doc.createElement("syn:loadbalance");
	       }else{
	       		rootFailover = doc.createElement("syn:failover");
	       }
	
	        rootElm.setAttribute("id", mainType+".0");
	
	        rootElm.appendChild(rootFailover);
	        doc.appendChild(rootElm);
	    }
	    else{
	        doc = newXmlFromString(payload);
	
	        //Asign ids to the endpoint nodes in the xml doc
	        var rootElement =  doc.documentElement;
	        rootElement.setAttribute("id", mainType+".0");
	        assignIds(rootElement.childNodes[0],mainType+".0");
	        YAHOO.util.Event.onDOMReady(createHTMLTree);
	
	    }
	}
}

function createMenu(){
	//Creating the menu
	oMenu = new YAHOO.widget.Menu("basicmenu");
	// Show the Menu instance
	
	var aMenuItems = [
	
	{ text: "Address" },
	{ text: "WSDL" },
	{ text: "Failover Group" },
	{ text: "Load-balance group"}
	
	        ];
	oMenu.addItems(aMenuItems);
}

//recursive method to fill the id values to config
function assignIds(elm,parentId){
    var splitId = parentId.split(".");

        var elmChilds = elm.childNodes;
        var j=0;
        for(var i = 0;i<elmChilds.length;i++){
            if(elmChilds[i].nodeName == "syn:endpoint"){
                var type= "";
                if(elmChilds[i].childNodes[0].nodeName =="syn:address") {
                    type = "address";
                }
                else if(elmChilds[i].childNodes[0].nodeName =="syn:wsdl") {
                    type = "wsdl";
                }
                else if(elmChilds[i].childNodes[0].nodeName =="syn:failover") {
                    type = "failover";
                }
                else {
                    type = "load";
                }
                var newId = type;
                for (var x = 1; x < splitId.length; x++) {
                    newId += ("." + splitId[x]);
                }
                newId += "." + j;
                elmChilds[i].setAttribute("id",newId);
                //Create the forms for each new ID (endpoint) created


                if(type == "address"){
                    createEditAddressForm(newId);
                }
                if(type == "wsdl"){
                   // createWSDLForm(newId);
                    createEditWSDLForm(newId);
                }

                //Call recursive method if the type is load or failover
                if(type == "failover"){
                    assignIds(elmChilds[i].childNodes[0],newId);
                }
                if(type == "load"){
                    createLoadBalanceForm(newId);
                    assignIds(elmChilds[i].childNodes[0],newId);
                }

                j++;
            }
        }
}

//This is the method called when the menu items are selected
function onMenuItemClick(e, e2, objx) {
    //Extracting the obj elements
    createXMLTree(objx[0], objx[1]);
    var treeRoot = document.getElementById("failoverTree");
    treeRoot.innerHTML = "";
    YAHOO.util.Event.onDOMReady(createHTMLTree);
    YAHOO.util.Event.onDOMReady(initEndpoints);

}

function createXMLTree(toid, type) {

    var mainEndpointNode = getNodeById(toid);

    //Get the failover of load-balance node under the syn:endpoint node to add sub element
    var addingFrom = mainEndpointNode.childNodes[0];
    var addingFromChildren = addingFrom.childNodes;
    var numChildren = addingFromChildren.length;
    var splitId = toid.split(".");
    var newId = type;
    for (var i = 1; i < splitId.length; i++) {
        newId += ("." + splitId[i]);
    }
    newId += "." + (numChildren + 1);
    //Put this id as the selected flag
    selectedFlag = newId;
    var newNodeToAdd = doc.createElement("syn:endpoint");
    newNodeToAdd.setAttribute("id", newId);

    var newSubNodeToAdd = "";

    if (type == "address") {
        newSubNodeToAdd = doc.createElement("syn:address");
    }
    if (type == "wsdl") {
        newSubNodeToAdd = doc.createElement("syn:wsdl");
    }
    if (type == "failover") {
        newSubNodeToAdd = doc.createElement("syn:failover");
    }
    if (type == "load") {
        newSubNodeToAdd = doc.createElement("syn:loadbalance");
    }
    newNodeToAdd.appendChild(newSubNodeToAdd);

    //Append the created xml node to the main xml object (doc)
    addingFrom.appendChild(newNodeToAdd);
   
    
    if (type == "address") {
        createEditAddressForm(newId);
    }
    if (type == "wsdl") {
        createEditWSDLForm(newId);
    }
    if (type == "failover") {
    }
    if (type == "load") {
    	createLoadBalanceForm(newId);
    }
    YAHOO.util.Event.onAvailable("form_" + newId, function() {
    	document.getElementById("form_" + newId).style.display = "";
    });

}
function getNodeById(id) {
    var subEndpoints = doc.getElementsByTagName("*");
    var toReturn = "";
    for (var i = 0; i < subEndpoints.length; i++) {
        if (subEndpoints[i].getAttribute('id') == id) toReturn = subEndpoints[i];
    }
    return toReturn;
}

function createHTMLTree() {
    var treeRoot = document.getElementById("failoverTree");
    var li = document.createElement("LI");

    //Check for the root child elements and update the tree
    var rootEndpoint = getNodeById(mainType+".0");
    var hasRootSubs = false;
    if (rootEndpoint.childNodes[0].childNodes.length >= 1) hasRootSubs = true;
    //alert(hasRootSubs);
    li.innerHTML = "<div class=\"endpoints\" id=\""+mainType+".0\">"+
	                        "<a class=\"root-endpoint\">root</a>"+
	                        "<div class=\"sequenceToolbar\" style=\"width: 100px;\">"+
					"<div>"+
					"<a class=\"addChildStyle\">Add Endpoint</a>"+
					"</div>"+
				"</div>"+
                        "</div>";

    //Add a vertical line if root node has children
    if (hasRootSubs) {
        li.innerHTML += "<div class=\"vertical-line-alone\"/>";
    }

    treeRoot.innerHTML = "";
    treeRoot.appendChild(li);
    //Extracting doc data
    createNodes(mainType+".0", treeRoot);
    selectNode(selectedFlag);
}
function createNodes(id, toAdd) {
    var rootEndpoint = getNodeById(id);
    var rootFailover = rootEndpoint.childNodes[0];
    var rootChildren = rootFailover.childNodes;
    var isLast;
    for (var i = 0; i < rootChildren.length; i++) {

        if (i == (rootChildren.length - 1)) {
            isLast = true;
        } else {
            isLast = false;
        }
        if (rootChildren[i].childNodes[0].nodeName == "syn:failover") {
            //Check wheather this failover node has child nodes
            var hasFailoverSubs = false;
            if (rootChildren[i].childNodes[0].childNodes.length >= 1) hasFailoverSubs = true;

            li = document.createElement("LI");
            li.innerHTML = "<div class=\"endpoints\" id=" + rootChildren[i].getAttribute("id") + "><a class=\"failover-endpoint\">Failover</a>"+
	                        "<div class=\"sequenceToolbar\">"+
					"<div><a class=\"addChildStyle\">Add Endpoint</a></div>"+
					"<div><a class=\"deleteStyle\">Delete</a></div>"+
				"</div>"+
            		   "</div>";
            if (hasFailoverSubs) {
                li.innerHTML += "<div class=\"branch-node\"></div>";
                var the_ul = document.createElement("UL");
                the_ul.className = "child-list";
                li.appendChild(the_ul);
                if (!isLast) {
                    li.className = "vertical-line";
                }
                toAdd.appendChild(li);

                //Call the recousive function
                createNodes(rootChildren[i].getAttribute("id"), the_ul);
            }

            else {
                if (!isLast) {
                    li.className = "vertical-line";
                }
                toAdd.appendChild(li);
            }


        }
        if (rootChildren[i].childNodes[0].nodeName == "syn:address") {
            li = document.createElement("LI");
            li.innerHTML = "<div class=\"endpoints\" id=" + rootChildren[i].getAttribute("id") + "><a class=\"address-endpoint\">Address</a>"+
	                        "<div class=\"sequenceToolbar\" style=\"width: 100px;\">"+
					"<div>"+
					"<a class=\"deleteStyle\">Delete</a>"+
					"</div>"+
				"</div>"+
            		   "</div>";

            if (!isLast) {
                li.innerHTML += "<div class=\"vertical-line-alone\"/>";
            }
            toAdd.appendChild(li);
        }
        if (rootChildren[i].childNodes[0].nodeName == "syn:wsdl") {

            li = document.createElement("LI");
            li.innerHTML = "<div class=\"endpoints\" id=" + rootChildren[i].getAttribute("id") + "><a class=\"wsdl-endpoint\">WSDL</a>"+
	                        "<div class=\"sequenceToolbar\" style=\"width: 100px;\">"+
					"<div>"+
					"<a class=\"deleteStyle\">Delete</a>"+
					"</div>"+
				"</div>"+
            		   "</div>";

            if (!isLast) {
                li.innerHTML += "<div class=\"vertical-line-alone\"/>";
            }
            toAdd.appendChild(li);
        }
        if (rootChildren[i].childNodes[0].nodeName == "syn:loadbalance") {
            
            //Check wheather this failover node has child nodes
            var hasLoadSubs = false;
            if (rootChildren[i].childNodes[0].childNodes.length >= 1) hasLoadSubs = true;

            li = document.createElement("LI");
            li.innerHTML = "<div class=\"endpoints\" id=" + rootChildren[i].getAttribute("id") + "><a class=\"failover-endpoint\">LoadBalance</a>"+
            		   	"<div class=\"sequenceToolbar\">"+
					"<div><a class=\"addChildStyle\">Add Endpoint</a></div>"+
					"<div><a class=\"deleteStyle\">Delete</a></div>"+
				"</div>"+
                           "</div>";
            if (hasLoadSubs) {
                li.innerHTML += "<div class=\"branch-node\"></div>";
                var the_ul = document.createElement("UL");
                the_ul.className = "child-list";
                li.appendChild(the_ul);
                if (!isLast) {
                    li.className = "vertical-line";
                }
                toAdd.appendChild(li);

                //Call the recousive function
                createNodes(rootChildren[i].getAttribute("id"), the_ul);
            }

            else {
                if (!isLast) {
                    li.className = "vertical-line";
                }
                toAdd.appendChild(li);
            }
        }
    }
}


//This method reads the dom tree of the html tree and register events and callback funtions for them
function initEndpoints() {

    var allDivs = document.getElementById("treePane").getElementsByTagName("*");
    var nodeDivs = new Array();
    var otherDivs = new Array();
    var addChildDivs = new Array();
    var deleteDivs = new Array();

   // YAHOO.util.Event.addListener("saveButton", "click", trigerSave);

    for (var i = 0; i < allDivs.length; i++) {
            if (YAHOO.util.Dom.hasClass(allDivs[i], "addChildStyle")  ) {
                addChildDivs.push(allDivs[i]);
            }
            if (YAHOO.util.Dom.hasClass(allDivs[i], "deleteStyle")  ) {
                deleteDivs.push(allDivs[i]);
            }
            if (YAHOO.util.Dom.hasClass(allDivs[i], "root-endpoint") || YAHOO.util.Dom.hasClass(allDivs[i], "failover-endpoint") || YAHOO.util.Dom.hasClass(allDivs[i], "load-endpoint") ) {
                nodeDivs.push(allDivs[i]);
            }
            if (YAHOO.util.Dom.hasClass(allDivs[i], "wsdl-endpoint") || YAHOO.util.Dom.hasClass(allDivs[i], "address-endpoint")) {
                otherDivs.push(allDivs[i]);
            }
    }
    for (i = 0; i < nodeDivs.length; i++) {
        YAHOO.util.Event.addListener(nodeDivs[i], "click", selectCallback, nodeDivs[i].parentNode.id);

    }
    for (i = 0; i < otherDivs.length; i++) {
        YAHOO.util.Event.addListener(otherDivs[i], "click", selectCallback, otherDivs[i].parentNode.id);
    }
    for (i = 0; i < addChildDivs.length; i++) {
        YAHOO.util.Event.addListener(addChildDivs[i], "click", menuCallback, [addChildDivs[i],addChildDivs[i].parentNode.parentNode.parentNode.id]);
    }
    for (i = 0; i < deleteDivs.length; i++) {
        YAHOO.util.Event.addListener(deleteDivs[i], "click", deleteCallback, [deleteDivs[i],deleteDivs[i].parentNode.parentNode.parentNode.id]);
    }
}
function cleanIds() {
    var docString = xmlToString(doc);
    var newDoc = newXmlFromString(docString);
    var allEndpoints = newDoc.getElementsByTagName("*");
    for (var i = 0; i < allEndpoints.length; i++) {
        allEndpoints[i].removeAttribute("id");
    }
    return newDoc;
}

String.prototype.trim = function() {
	return this.replace(/^\s+|\s+$/g,"");
}
String.prototype.ltrim = function() {
	return this.replace(/^\s+/,"");
}
String.prototype.rtrim = function() {
	return this.replace(/\s+$/,"");
}
function processReqChange() {
    // only if req shows "loaded"
    if (req.readyState == 4) {
        // only if "OK"

        if (req.status == 200) {
              if(req.responseText.trim()=='noerr'){
              location.href="index.jsp";
            }
            else{
                CARBON.showWarningDialog(req.responseText.trim());
            }
        } else {
            CARBON.showErrorDialog("There was a problem retrieving the XML data:\n" +
                req.statusText);
            CARBON.showErrorDialog(req.getResponseHeader())
        }
    }
}

//This is to generate the menu when someone clicks a failover or loab-balance group
function menuCallback(e, obj) {
    var parms = [obj[0],'bl','tr'];
    if (!doValidation('true')) return;
    
    selectNode(obj[1]);
    //Select the form
	
    oMenu.getItem(0).cfg.setProperty("onclick", { fn: onMenuItemClick, obj: [obj[1],"address"] });
    oMenu.getItem(1).cfg.setProperty("onclick", { fn: onMenuItemClick, obj: [obj[1],"wsdl"] });
    oMenu.getItem(2).cfg.setProperty("onclick", { fn: onMenuItemClick, obj: [obj[1],"failover"] });
    oMenu.getItem(3).cfg.setProperty("onclick", { fn: onMenuItemClick, obj: [obj[1],"load"] });


    oMenu.cfg.setProperty('context', parms);

    oMenu.render(document.body);

    oMenu.show();
}
function deleteCallback(e, obj){
	var nodeIdToRemove = obj[1];
	CARBON.showConfirmationDialog('Are you sure you whant to delete this endpoint?', function(){
		var nodeToRemove = getNodeById(nodeIdToRemove);
		nodeToRemove.parentNode.removeChild(nodeToRemove);
		selectedFlag = mainType+".0";
		//Update the tree
		var treeRoot = document.getElementById("failoverTree");
	    	treeRoot.innerHTML = "";
	    	YAHOO.util.Event.onDOMReady(createHTMLTree);
	    	YAHOO.util.Event.onDOMReady(initEndpoints);
	},null);
}
//This is to select the from when someone clicks an icon
function selectCallback(e, obj) {
    if (!doValidation('true')) return;
    selectNode(obj);
}

function selectNode(objId) {
    var endpointDesign=document.getElementById('endpointDesign');
    var selectedType = objId.split(".")[0];
    
    if(selectedType == "failover" || objId=="load.0"){
    	endpointDesign.style.display = "none";
    } else {
    	endpointDesign.style.display = "";
    }
    var allNodes = document.getElementById("treePane").getElementsByTagName("*");
    for (var i = 0; i < allNodes.length; i++) {
        if (YAHOO.util.Dom.hasClass(allNodes[i], "selected-node")) {
            YAHOO.util.Dom.removeClass(allNodes[i], "selected-node");
        }
    }
    selectedFlag = objId;
    var nodeToFillList = document.getElementById(objId).childNodes;
    var nodeToFill;
    for(var j=0;j<nodeToFillList.length;j++){
    	if(nodeToFillList[j].nodeName == "A"){
    		nodeToFill = nodeToFillList[j];
    	}
    }
    YAHOO.util.Dom.addClass(nodeToFill, "selected-node");

    //Select the form
    hideOtherForms(selectedFlag);
}
/**
 * Create a new Document object. If no arguments are specified,
 * the document will be empty. If a root tag is specified, the document
 * will contain that single root tag. If the root tag has a namespace
 * prefix, the second argument must specify the URL that identifies the
 * namespace.
 */
function newXML(rootTagName, namespaceURL) {
    if (!rootTagName) rootTagName = "";
    if (!namespaceURL) namespaceURL = "";
    if (document.implementation && document.implementation.createDocument) {
        // This is the W3C standard way to do it
        return document.implementation.createDocument(namespaceURL, rootTagName, null);
    }
    else { // This is the IE way to do it
        // Create an empty document as an ActiveX object
        // If there is no root element, this is all we have to do
        var doc = new ActiveXObject("MSXML2.DOMDocument");
    // If there is a root tag, initialize the document
        if (rootTagName) {
            // Look for a namespace prefix
            var prefix = "";
            var tagname = rootTagName;
            var p = rootTagName.indexOf(':');
            if (p != -1) {
                prefix = rootTagName.substring(0, p);
                tagname = rootTagName.substring(p + 1);
            }
      // If we have a namespace, we must have a namespace prefix
            // If we don't have a namespace, we discard any prefix
            if (namespaceURL) {
                if (!prefix) prefix = "a0"; // What Firefox uses
            }
            else prefix = "";
      // Create the root element (with optional namespace) as a
            // string of text
            var text = "<" + (prefix ? (prefix + ":") : "") + tagname +
                       (namespaceURL
                               ? (" xmlns:" + prefix + '="' + namespaceURL + '"')
                               : "") +
                       "/>";
      // And parse that text into the empty document
            doc.loadXML(text);
        }
        return doc;
    }
}
function newXmlFromString(text){

    try //Internet Explorer
      {
      xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
      xmlDoc.async="false";
      xmlDoc.loadXML(text);
      }
    catch(e)
      {
      try //Firefox, Mozilla, Opera, etc.
        {
        parser=new DOMParser();
        xmlDoc=parser.parseFromString(text,"application/xml");
        }
      catch(e) {//alert(e.message)
           }
      }
    return xmlDoc;

}

function hideOtherForms(id) {
    var allForms = document.getElementById("info").childNodes;

    for (var i = 0; i < allForms.length; i++) {
        if (allForms[i].nodeName == "DIV")allForms[i].style.display = "none";
    }
    if (document.getElementById("form_" + id) != null)document.getElementById("form_" + id).style.display = "";
}
function xmlToString(xmlObj) {
    if (navigator.appName == "Netscape")
    {
       return (new XMLSerializer()).serializeToString(xmlObj);
    }
    if (navigator.appName == "Microsoft Internet Explorer")
    {
        return xmlObj.xml;
    }
}
function trigerSave(toUrl) {
    if (!doValidation('true')) {
        window.location = "#";
        return;
    }



    //doValidation();
    var newDoc = cleanIds();
    //alert(xmlToString(newDoc));
    var na = document.getElementById("mainName").value;
    var param = "name="+xmlToString(newDoc)+"&"+"epname="+na;
    var url = toUrl;
    req = false;

        // branch for native XMLHttpRequest object
        if(window.XMLHttpRequest && !(window.ActiveXObject)) {
            try {
                req = new XMLHttpRequest();
            } catch(e) {
                req = false;

            }
        // branch for IE/Windows ActiveX version
        } else if(window.ActiveXObject) {
               try {
                req = new ActiveXObject("Msxml2.XMLHTTP");
              } catch(e) {
                try {
                      req = new ActiveXObject("Microsoft.XMLHTTP");
                } catch(e) {
                      req = false;
                }
            }
        }

        if(req) {
            req.onreadystatechange = processReqChange;

           // req.open("GET", url, true);
            req.open("POST", url, true)
            req.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
            req.send(param)
            //req.send("");
        }
}