<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@ page import="java.util.regex.Pattern" %>
<%@ page import="java.util.regex.Matcher" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.EndpointSerializer" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.EndpointFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.synapse.endpoints.LoadbalanceEndpoint" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">
    <carbon:breadcrumb
		label="load.balance.endpoint"
		resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
		topPage="false"
		request="<%=request%>" />
<div>
       <link type="text/css" rel="stylesheet" href="css/menu.css"/>
    <link type="text/css" rel="stylesheet" href="css/style.css"/>

    <!-- Dependencies -->
    <script type="text/javascript" src="yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
    <script type="text/javascript" src="yui/build/container/container_core-min.js"></script>


    <!-- Connection handling lib -->
    <script type="text/javascript" src="yui/build/yahoo/yahoo-min.js"></script>
    <script type="text/javascript" src="yui/build/event/event-min.js"></script>
    <script type="text/javascript" src="yui/build/connection/connection-min.js"></script>
    <script type="text/javascript" src="../resources/js/resource_util.js"></script>
    <!-- Source File -->

    <script type="text/javascript" src="yui/build/menu/menu-min.js"></script>
    <%
        String payload = "null";
        String epname = null;
        String payloadFromSrc = null;
        String epMode = null;
        OMElement ele = null;
        epname = request.getParameter("epName");
        if((payload = request.getParameter("xmlpayload"))!=null){
            if ((epMode = (String) session.getAttribute("epMode")) != null && "anon".equals(epMode)) {
                // came to this page from source view so we have the xmlpayload, but still we are in anon mode
                // adds the dummy name, i.e. anonymous
                try {
                    payload = EndpointAdminClient.getAnonEpXMLwithName(payload);
                } catch (XMLStreamException e) {
                    // todo - handle error
                }
            }
            payloadFromSrc = formatXML(payload);
            try{
                ele = AXIOMUtil.stringToOM(payloadFromSrc);
            }
            catch(XMLStreamException e){

            }
            try{
            LoadbalanceEndpoint ep = (LoadbalanceEndpoint) EndpointFactory.getEndpointFromElement(ele,false);
            epname = ep.getName();
            OMElement eleFromEp = EndpointSerializer.getElementFromEndpoint(ep);
            payload = formatXML(eleFromEp.toString());
            }
            catch(Exception e){
            String errMsg = e.getMessage();
            String dspMsg = errMsg.replaceAll("\\'","");
            %>
                <script type="text/javascript">
                jQuery(document).ready(function(){
    CARBON.showErrorDialog('<%=dspMsg%>');
           });
</script>
           <%
            payload="null";
}
        } else if ((epMode = (String) session.getAttribute("epMode")) != null && "anon".equals(epMode)) {
            // we are in anon mode
            String anonEpXML;
            if ((anonEpXML = (String)session.getAttribute("anonEpXML")) != null && !"".equals(anonEpXML)) {
                // an endpoint data is present in the anon mode, i.e. editing an anon endpoint
                try {
                    // adds a dummy name (i.e. anonymous) to the endpoint
                    payload = formatXML(EndpointAdminClient.getAnonEpXMLwithName(anonEpXML));
                } catch (XMLStreamException e) {
                    // todo - handle error
                }
            }
        } else if (epname != null) {
            if (session.getAttribute(epname) != null) {
                payload = (String) session.getAttribute(epname);
                // out.println(payload);
            }
        }
    %>
    <%!
        String formatXML(String xml) {
            String afterReplace = "";
            Pattern p;
            Matcher m;
            p = Pattern.compile("\\s+");
            m = p.matcher(xml);
            afterReplace = afterReplace + m.replaceAll(" ") + "\r\n";
            return afterReplace.trim();
        }
    %>
    <script type="text/javascript">

        var payload='<%=payload%>';

    </script>
    <!-- Local files -->
    <script type="text/javascript" src="js/forms.js"></script>
    <script type="text/javascript" src="js/ep_common.js"></script>
    <script type="text/javascript" src="js/lbendpoint.js"></script>
    <script type="text/javascript" src="js/lbvalidation.js"></script>
    <script type="text/javascript" src="js/tabs.js"></script>
    <script type="text/javascript">

        YAHOO.util.Event.onDOMReady(init);
        function init() {
            initEndpoints();
            if ('<%=epMode%>' != null && '<%=epMode%>' == 'anon') {
                document.getElementById("nameLabel").style.display = 'none';
                document.getElementById("mainName").style.display = 'none';
                // sets the dummy name, i.e. anonymous
                document.getElementById('mainName').value='anonymous';
            } else {
                // we are in normal mode
                showHideTreeBasedOnName();
                if (document.getElementById('mainName').value == "") {
                    document.getElementById('treePane').style.display = "none";
                }
            }
        }

        function cancelData() {<%
        String anonEpOriginator;
        if ((anonEpOriginator = (String)session.getAttribute("anonOriginator")) != null
            && !"".equals(anonEpOriginator)) {%>
             window.location.href = '<%=anonEpOriginator%>?cancelled=true';
         <%} else {%>
             window.location.href = 'index.jsp';
         <%}%>
        }

        function saveData() {
            if ('<%=epMode%>' != null && '<%=epMode%>' == 'anon') {
                // anon mode saving
                if (!doValidation()) {
                    window.location = "#";
                    return;
                }
                var newDoc = cleanIds();
                document.loadbalanceAnonHandlerForm.anonEpXML.value = xmlToString(newDoc);
                document.loadbalanceAnonHandlerForm.action = "anonEpHandler.jsp";
                document.loadbalanceAnonHandlerForm.submit();
            } else {
                var sesVal = document.getElementById('sesTimeout');
                if(isNaN(sesVal.value)){
                    CARBON.showWarningDialog('Please enter a numeric value to the session timeout field');
                    return;
                }
                trigerSave('loadbalanceEndpointCaller-ajaxprocessor.jsp');
            }
        }

        function srcView(){
            document.loadbalanceForm.payload.value= checkDesign();
            document.loadbalanceForm.action='loadbalanceSourceView.jsp';
            document.loadbalanceForm.submit();
        }

        function showHideTreeBasedOnName() {
            var name = document.getElementById('mainName').value;
            if (name != "") {
                document.getElementById('treePane').style.display = "";
                if (doValidation('true'))selectNode("load.0");
            } else {
                document.getElementById('treePane').style.display = "none";
                document.getElementById('endpointDesign').style.display = "none";
            }
        }
    </script>

<div id="middle">

<h2><fmt:message key="load.balance.endpoint"/></h2>
<div id="workArea">
       <table class="styledLeft">
<thead>
    <tr>
        <th>
        	<span style="float: left; position: relative; margin-top: 2px;"><fmt:message key="design.view.of.the.load.balance.endpoint"/></span>
		<a class="icon-link" style="background-image: url(images/source-view.gif);" onclick="srcView()" href="#"><fmt:message key="switch.to.source.view"/></a>
	</th>
    </tr>
</thead>
<tr><td>

    <form action="" name="loadbalanceAnonHandlerForm" method="POST">
        <input type="hidden" name="anonEpXML"/>
    </form>
    <form action="" method="POST" name="loadbalanceForm">
                <input type="hidden" name="payload"/>
                </form>
<div class="error-message" id="errorDiv" style="display:none;"></div>
<div class="input-area">
<table class="normal" cellspacing="0" width="100%"><tr><td>
    <label id="nameLabel"><fmt:message key="endpoint.name"/> <span class="required">*</span></label>
        <%if(epname!=null && (!(epname.equalsIgnoreCase(""))) && (request.getParameter("xmlpayload")==null)){%>
    <input type="text" class="textbox" id="mainName" value="<%=epname%>" readonly="readonly" style="background-color:lightgray;"/>
    <%}else if(epname!=null && (request.getParameter("xmlpayload")!=null)){%>
    <input type="text" class="textbox" id="mainName" value="<%=epname%>" onkeypress="return validateText(event);" onkeyup="showHideTreeBasedOnName();"/>
    <%}else{%>
    <input type="text" class="textbox" id="mainName" onkeypress="return validateText(event);" onkeyup="showHideTreeBasedOnName();"/>
    <%}%>

</td>
</tr>
<tr>
<td>
    <label><fmt:message key="session.management"/></label>
    <%
        String sesType = null;
        if(epname!=null && ((session.getAttribute(epname+"sesType"))!=null)){%>
    <% sesType = (String)session.getAttribute(epname+"sesType");
    if(sesType.equalsIgnoreCase("http")){%>
    <select name="sesManagement" id="sesOptions">
    <option value="http">Transport</option>
    <option value="SelectAValue">None</option>
    <option value="soap">SOAP</option>
    <option value="simpleClientSession">Client ID</option>
</select>
   <% }else if(sesType.equalsIgnoreCase("soap")){ %>
    <select name="sesManagement" id="sesOptions">
    <option value="soap">SOAP</option>
    <option value="http">Transport</option>
    <option value="SelectAValue">None</option>
    <option value="simpleClientSession">Client ID</option>
</select>
    <%}else if(sesType.equalsIgnoreCase("simpleClientSession")){%>
    <select name="sesManagement" id="sesOptions">
    <option value="simpleClientSession">Client ID</option>
    <option value="soap">SOAP</option>
    <option value="http">Transport</option>
    <option value="SelectAValue">None</option>
</select>
    <%}else{%>
    <select name="sesManagement" id="sesOptions">
    <option value="SelectAValue">None</option>
    <option value="http">Transport</option>
    <option value="soap">SOAP</option>
    <option value="simpleClientSession">Client ID</option>
</select>
    <%}%>
    <%}else{%>
    <select name="sesManagement" id="sesOptions">
    <option value="SelectAValue">None</option>
    <option value="http">Transport</option>
    <option value="soap">SOAP</option>
    <option value="simpleClientSession">Client ID</option>
</select>
    <%}%>
</td>
</tr>
<tr>
<td>
    <label><fmt:message key="session.timeout.ms"/> </label>
    <%if(epname!=null && (sesType!=null) && (!(sesType.equalsIgnoreCase("SelectAValue")))){
       String sesTimeout = (String)session.getAttribute(epname+"sesTimeout"); %>
    
       <input type="text" class="textbox" id="sesTimeout" value="<%=sesTimeout%>"/>
    <%}else{%>
    <input type="text" class="textbox" id="sesTimeout"/>
    <%}%>
</td>
</tr>
</table>
</div>
<table class="normal" cellspacing="0" width="100%">
<tr>
<td>
<div class="treePane" id="treePane" style="height: 300px; overflow: auto; width: auto; border: 1px solid rgb(204, 204, 204);position:relative;">
    <ul class="root-list" id="failoverTree">
            <li>
                <div class="endpoints" id="load.0">
                        <a class="root-endpoint">root</a>
                        <div class="sequenceToolbar" style="width: 100px;">
				<div>
				<a class="addChildStyle">Add Endpoint</a>
				</div>
			</div>
                </div>
            </li>
        </ul>
</div>
</td>
</tr>
</table>
    <%--
<ul class="tabPane">
    <li class="selected" onclick="checkSource();makeSelected(this,'endpoint')">Design</li>
    <li onclick="checkDesign();makeSelected(this,'endpoint')">Source</li>
</ul>   --%>
<div id="endpointDesign">
<table class="normal" width="100%">
			<tr>
				<td>
					<table class="styledLeft" cellspacing="0" style="margin-left: 0px;">
						<tr>
				                        <td class="middle-header" >
								<span style="float:left; position:relative; margin-top:2px;"><fmt:message key="design.view.of.the.endpoint"/></span></a>	
				                        </td>
				                </tr>
						<tr>
							<td style="padding: 0px !important;">
    <div id="info" class="tabPaneContentMain"></div>
</td>
						</tr>
					</table>		
				</td>
			</tr>
		</table>
</div>
    
<div id="registryBrowser" style="display:none;"></div>

</td></tr>
<tr><td class="buttonRow">
    <input type="button" value="<fmt:message key="save"/>" id="saveButton" class="button" onclick="saveData();"/>&nbsp;<input type="button" value="<fmt:message key="cancel"/>" class="button" onclick="cancelData();"/>

</td>
</tr>
</table>
    </div>
</div>
</fmt:bundle>