<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="org.wso2.carbon.utils.xml.XMLPrettyPrinter" %>
<%@ page import="java.io.*" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<fmt:bundle basename="org.wso2.carbon.endpoints.ui.i18n.Resources">
    <carbon:breadcrumb
		label="address.endpoint.source"
		resourceBundle="org.wso2.carbon.endpoints.ui.i18n.Resources"
		topPage="false"
		request="<%=request%>" />
    <link type="text/css" rel="stylesheet" href="css/style.css"/>

    
    <div>
     <script type="text/javascript">
         function viewDesign(){
//	var txtVal = document.getElementById("test").value;
//	document.location.href='addressEndpointCaller.jsp?'+'epXML='+txtVal;
             document.xmlPayloadForm.action='addressEpbuilder.jsp';
             document.xmlPayloadForm.submit();
         }

        function submitData(){
            //var payload = document.getElementById('xmlPay').value;
            document.xmlPayloadForm.action='addEpSrcSaveHelper.jsp';
	        document.xmlPayloadForm.submit();
        }

         function cancelData() {
         <%
        String anonEpOriginator;
        if ((anonEpOriginator = (String)session.getAttribute("anonOriginator")) != null
            && !"".equals(anonEpOriginator)) {%>
             window.location.href = '<%=anonEpOriginator%>?cancelled=true';
         <%} else {%>
             window.location.href = 'index.jsp';
         <%}%>
         }

     </script>
         <%!private static final String SYNAPSE_NS = "http://ws.apache.org/ns/synapse";
           private HttpServletRequest req = null;
           private static final String gt = ">";
           private static final String lt = "<";
	   PrintWriter out = null;
        %>
<%! private String getAddressEndpointXML(HttpSession session){

            
    String name = req.getParameter("Name");
    String address = req.getParameter("Address");


    String format = req.getParameter("Format");
    String optimize = req.getParameter("Optimize");
    String susDuration = null;
    if(!(req.getParameter("DurationSec")==null)){
        susDuration = req.getParameter("DurationSec");
    }
    String timeOutAction = req.getParameter("Action");
    String actionDurSec = req.getParameter("DurationInAction");
    String wsAddEnable = req.getParameter("wsAddEnable");
    String sepListener = req.getParameter("sepLis");
    String wsSecEnable = req.getParameter("wsSec");
    String wsRmEnable = req.getParameter("wsRm");
    String errorCodes = req.getParameter("errCodes");
    String maxDur = req.getParameter("maxDur");
    String factor = req.getParameter("factor");
    String retryDelay = req.getParameter("retryDelay");
    String retry = req.getParameter("retry");
    String timeoutErrCodes = req.getParameter("timoutErr");
    String secPolKey = req.getParameter("polKey");
    String rmPolKey = req.getParameter("rmpolKey");

    StringBuilder addXML = new StringBuilder();
    addXML.append(lt+"syn:endpoint xmlns:syn=\""+SYNAPSE_NS+"\"");
    // removes name attribute if in anon mode
    String epMode = null;
    if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
        addXML.append(gt);
    } else {
        addXML.append(" name=\""+name.trim()+"\""+gt);
    }
    addXML.append(lt+"syn:address uri=\""+address);
    addXML.append("\"");

    if(format!=null){
        if(!(format.equalsIgnoreCase("Leave As-Is"))){
            addXML.append(" format=\"");
            if(format.contains("SOAP 1.1")){
                addXML.append("soap11");
            }
            else if(format.contains("SOAP 1.2")){
                addXML.append("soap12");
            }
            else if(format.contains("Plain Old XML (POX)")){
                addXML.append("pox");
            }
            else{
                addXML.append("get");
            }
            addXML.append("\"");
        }
    }

    if(optimize!=null){

        if(!(optimize.equalsIgnoreCase("Leave As-Is"))){
            addXML.append(" optimize=\"");
            if(optimize.equalsIgnoreCase("SwA")){
                addXML.append("swa");
            }
            else{
                addXML.append("mtom");
            }
            addXML.append("\"");
        }

    }
    addXML.append(" "+gt);
    String susXML = "";
    //put a javascript to check if value entered is a number
    if(!(susDuration.equalsIgnoreCase(""))){
        if(Integer.valueOf(susDuration) >0){
            susXML = "<syn:suspendOnFailure><syn:initialDuration>"+ Long.valueOf(susDuration.trim())+"</syn:initialDuration>";

        }
    }

    if(!(errorCodes.equalsIgnoreCase(""))){
        if(susXML.equalsIgnoreCase("")){
            susXML = "<syn:suspendOnFailure>"+"<syn:errorCodes>"+ errorCodes.trim()+ "</syn:errorCodes>";
        }
        else{
            susXML += "<syn:errorCodes>"+ errorCodes.trim()+ "</syn:errorCodes>";
        }
    }

    if((!(susXML.equalsIgnoreCase("")))){

        if(!(maxDur.equalsIgnoreCase(""))){
            susXML += "<syn:maximumDuration>"+ Long.valueOf(maxDur)+"</syn:maximumDuration>";
        }
        if(!(factor.equalsIgnoreCase(""))){
            susXML += "<syn:progressionFactor>"+ Float.valueOf(factor)+"</syn:progressionFactor>";
        }
        else{
            susXML += "<syn:progressionFactor>"+"0.0"+"</syn:progressionFactor>";
        }
        susXML+= "</syn:suspendOnFailure>";
        addXML.append(susXML);
    }

   String timedoutXML = "";
    if(!(retry.equalsIgnoreCase(""))){
        if(Integer.valueOf(retryDelay).intValue()>0){
            timedoutXML += "<syn:markForSuspension><syn:retryDelay>"+retry+"</syn:retryDelay>";
        }
    }

    if(!(timeoutErrCodes.equalsIgnoreCase(""))){
        if(timedoutXML.equalsIgnoreCase("")){
            timedoutXML ="<syn:markForSuspension><syn:errorCodes>"+timeoutErrCodes+"</syn:errorCodes>";
        }
        else{
            timedoutXML +="<syn:errorCodes>"+timeoutErrCodes+"</syn:errorCodes>";
        }
    }

    if(!((timedoutXML.equalsIgnoreCase("")))){

        if(!(retryDelay.equalsIgnoreCase(""))){
            timedoutXML +="<syn:retriesBeforeSuspension>"+retryDelay+"</syn:retriesBeforeSuspension>";

        }
        timedoutXML += "</syn:markForSuspension>";
        addXML.append(timedoutXML);
    }
    if(wsAddEnable!=null && wsAddEnable.equalsIgnoreCase("checked")){

        if(sepListener!=null && sepListener.equalsIgnoreCase("checked")){
            addXML.append(lt+"syn:enableAddressing separateListener='true'/"+gt)  ;
        }
        else{
            addXML.append(lt+"syn:enableAddressing/"+gt);
        }

    }

    if(timeOutAction!=null && (!(timeOutAction.equalsIgnoreCase("Never timeout")))){

        addXML.append(lt+"syn:timeout"+gt+" ");
        addXML.append(lt+"syn:action"+gt+" ");
        if(timeOutAction.equalsIgnoreCase("Discard message")){
            addXML.append("discard");
        }
        else{
            addXML.append("fault");
        }
        addXML.append(lt+"/syn:action"+gt+" ");

        if(actionDurSec!=null){
            addXML.append(lt+"syn:duration"+gt+Long.valueOf(actionDurSec.trim())+lt+"/syn:duration"+gt+" ");
        }

        addXML.append(lt+"/syn:timeout"+gt);
    }
    if(wsRmEnable!=null && (wsRmEnable.equalsIgnoreCase("checked"))){
                if(rmPolKey==null){
                addXML.append("<syn:enableRM/>");
                }
                else {
                    addXML.append("<syn:enableRM ");
                    addXML.append("policy=\""+rmPolKey+"\"");
                    addXML.append("></syn:enableRM>");
                }
            }
            if(wsSecEnable!=null && wsSecEnable.equalsIgnoreCase("checked")){
                if(secPolKey==null){
                addXML.append("<syn:enableSec/>");
                }
                 else {
                    addXML.append("<syn:enableSec ");
                    addXML.append("policy=\""+secPolKey+"\"");
                    addXML.append("></syn:enableSec>");
                }
            }

    addXML.append(lt+"/syn:address"+gt);
    addXML.append(lt+"/syn:endpoint"+gt);
    return addXML.toString().trim();
}

%>
     <%
         req = request;
         String srcPayload = getAddressEndpointXML(session);
         //session.setAttribute("xmlpayload",ss);
         //String sourceXML = request.getParameter("source");
         //String srcPayload = (String)session.getAttribute("xmlpayload");
         ByteArrayInputStream stream = new ByteArrayInputStream(srcPayload.getBytes());
         XMLPrettyPrinter printer = new XMLPrettyPrinter(stream);
         srcPayload = printer.xmlFormat();

         //return printer.xmlFormat();
         // session.removeAttribute("xmlpayload");
         session.setAttribute("page","address");
         session.setAttribute("savePage","AddressEndpoint.jsp");
     %>
     <div id="middle">
         <h2><fmt:message key="address.endpoint.source"/></h2>
         <div id="workArea">
             <form name="xmlPayloadForm" action="" method="POST">
                 <table class="styledLeft">
                     <thead>
                     <tr>
                         <th>
				<span style="float: left; position: relative; margin-top: 2px;"><fmt:message key="source.view.of.the.addressendpoint"/></span>
				<a href="#" class="icon-link" style="background-image: url(images/design-view.gif);" onclick="viewDesign()"> <fmt:message key="switch.to.design.view"/></a>
			</th>
                     </tr>
                     </thead>
                     <tr><td><textarea id="xmlPay" name="xmlpayload" style="border: 0px solid rgb(204, 204, 204); width: 99%; height: 275px; margin-top: 5px;" rows="30"><%=srcPayload%></textarea></td></tr>
                     <tr>

                         <td class="buttonRow">
                             <input type="button" value="<fmt:message key="save"/>" class="button" name="save" onclick="submitData();"/>
                             <input type="button" value="<fmt:message key="cancel"/>" name="cancel" class="button" onclick="cancelData();"/>
                         </td>
                     </tr>

                 </table>
             </form>
         </div>
     </div>
    </div>
</fmt:bundle>