<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@ page import="org.wso2.carbon.endpoint.service.EndpointAdminStub" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.wso2.carbon.endpoint.tos.xsd.*" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.*" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="java.io.*" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.endpoint.ui.client.EndpointAdminClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axiom.om.OMAttribute" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>


<div>
        <%! HttpServletRequest req = null;
            private static final String SYNAPSE_NS = "http://ws.apache.org/ns/synapse";
            private static final String gt = ">";
            private static final String lt = "<";
        %>


        <script type="text/javascript">
            function forward(){
                location.href="index.jsp";
            }

            function forwardDesign(ep){location.href="wsdlEndpoint.jsp?endpointName="+ep;}
        </script>

        <%!

             private boolean errCodesValidator(String errCodes){
        String [] errorCodes = errCodes.split(",");
        for(int i=0;i<errorCodes.length;i++){
            try{
                 int iErrChecker = Integer.parseInt(errorCodes[i]);
            }
            catch(NumberFormatException e){
                return false;
            }
        }
        return true;
    }
            public String getWDSLXML(boolean anon) throws Exception{
                String name = req.getParameter("Name");
                String uriChecked = req.getParameter("uri");
                String inlineVal = req.getParameter("inlineval");
                String address = req.getParameter("wsdlUri");
                String service = req.getParameter("service");
                String port = req.getParameter("port");
                String susDuration = req.getParameter("DurationSec");
                String timeOutAction = req.getParameter("Action");
                String actionDurSec = req.getParameter("DurationInAction");
                String wsAddEnable = req.getParameter("wsAddEnable");
                String sepListener = req.getParameter("sepLis");
                String wsSecEnable = req.getParameter("wsSec");
                String wsRmEnable = req.getParameter("wsRm");

                String errorCodes = req.getParameter("errCodes");
                String maxDur = req.getParameter("maxDur");
                String factor = req.getParameter("factor");
                String retryDelay = req.getParameter("retryDelay");
                String retry = req.getParameter("retry");
                String timeoutErrCodes = req.getParameter("timoutErr");
                String secPolKey = req.getParameter("polKey");
                String rmPolKey = req.getParameter("rmpolKey");

                StringBuilder bodyxml = new StringBuilder();

                bodyxml.append("<syn:endpoint xmlns:syn=\"" + SYNAPSE_NS + "\"");
                if (anon) {
                    bodyxml.append(gt);
                } else {
                    bodyxml.append(" name=\"" + name.trim() + "\"" + gt);
                }
                bodyxml.append("<syn:wsdl ");

                if (uriChecked != null && (uriChecked.equalsIgnoreCase("URI"))) {
                    bodyxml.append("uri=\"" + address + "\"");
                }

                if (service != null) {
                    bodyxml.append("  service=\"" + service + "\"");
                }

                if (port != null) {
                    bodyxml.append("  port=\"" + port + "\"" + ">");
                }

                if (uriChecked != null && (uriChecked.equalsIgnoreCase("InlinedWsdl"))) {
                    bodyxml.append(inlineVal.trim());
                }

                if (timeOutAction != null && (!(timeOutAction.equalsIgnoreCase("Never timeout")))) {
                    bodyxml.append("<syn:timeout> ");
                    bodyxml.append("<syn:action> ");

                    if (timeOutAction.equalsIgnoreCase("Discard message")) {
                        bodyxml.append("discard");
                    } else {
                        bodyxml.append("fault");
                    }
                    bodyxml.append("</syn:action> ");

                    if (actionDurSec != null) {
                        bodyxml.append("<syn:duration>" + Long.valueOf(actionDurSec.trim()) + "</syn:duration> ");
                    }
                    bodyxml.append("</syn:timeout>");

                }


                String susXML = null;
                //put a javascript to check if value entered is a number
                if (!(susDuration.equalsIgnoreCase(""))) {
                    if (Integer.valueOf(susDuration).intValue() > 0) {
                        susXML = "<syn:suspendOnFailure><syn:initialDuration>" + Long.valueOf(susDuration.trim()) + "</syn:initialDuration>";

                    }
                }

                if (!(errorCodes.equalsIgnoreCase(""))) {
                    if(errCodesValidator(errorCodes)){
                    if (susXML==null) {
                        susXML = "<syn:suspendOnFailure>" + "<syn:errorCodes>" + errorCodes.trim() + "</syn:errorCodes>";
                    } else {
                        susXML += "<syn:errorCodes>" + errorCodes.trim() + "</syn:errorCodes>";
                    }
                    }
                    else{
                        throw new Exception("Error Codes are invalid, Please enter only numeric values");
                    }
                }

                if (susXML!=null) {
                    if (!(maxDur.equalsIgnoreCase(""))) {
                        susXML += "<syn:maximumDuration>" + Long.valueOf(maxDur) + "</syn:maximumDuration>";
                    }
                    if (!(factor.equalsIgnoreCase(""))) {
                        susXML += "<syn:progressionFactor>" + Float.valueOf(factor) + "</syn:progressionFactor>";
                    } else {
                        susXML += "<syn:progressionFactor>" + "0.0" + "</syn:progressionFactor>";
                    }
                    susXML += "</syn:suspendOnFailure>";
                    bodyxml.append(susXML);
                }

                String timedoutXML = null;
                if (!(retryDelay.equalsIgnoreCase(""))) {
                    if (Integer.valueOf(retryDelay).intValue() > 0) {
                        timedoutXML += "<syn:markForSuspension><syn:retryDelay>" + retryDelay + "</syn:retryDelay>";
                    }
                }

                if (!(timeoutErrCodes.equalsIgnoreCase(""))) {
                    if (timedoutXML==null) {
                        timedoutXML = "<syn:markForSuspension><syn:errorCodes>" + timeoutErrCodes + "</syn:errorCodes>";
                    } else {
                        timedoutXML += "<syn:errorCodes>" + timeoutErrCodes + "</syn:errorCodes>";
                    }
                }

                if (timedoutXML!=null) {
                    if (!(retry.equalsIgnoreCase(""))) {
                        timedoutXML += "<syn:retriesBeforeSuspension>" + retry + "</syn:retriesBeforeSuspension>";

                    }
                    timedoutXML += "</syn:markForSuspension>";
                    bodyxml.append(timedoutXML);
                }

                if (wsAddEnable != null && (wsAddEnable.equalsIgnoreCase("checked"))) {
                    if (sepListener != null && (sepListener.equalsIgnoreCase("checked"))) {
                        bodyxml.append("<syn:enableAddressing separateListener='true'/>");
                    } else {
                        bodyxml.append("<syn:enableAddressing/>");
                    }
                }

                if (wsRmEnable != null && (wsRmEnable.equalsIgnoreCase("checked"))) {
                    if(rmPolKey==null){
                    bodyxml.append("<syn:enableRM/>");
                }
                else {
                    bodyxml.append("<syn:enableRM ");
                    bodyxml.append("policy=\""+rmPolKey+"\"");
                    bodyxml.append("></syn:enableRM>");
                }
                }
                if (wsSecEnable != null && wsSecEnable.equalsIgnoreCase("checked")) {
                    if(secPolKey==null){
                bodyxml.append("<syn:enableSec/>");
                }
                 else {
                    bodyxml.append("<syn:enableSec ");
                    bodyxml.append("policy=\""+secPolKey+"\"");
                    bodyxml.append("></syn:enableSec>");
                }
                }

                bodyxml.append("</syn:wsdl>");
                bodyxml.append("</syn:endpoint>");

                return bodyxml.toString().trim();
            }
        %>

        <%
            req = request;
            String name = request.getParameter("Name");
            String url = CarbonUIUtil.getServerURL(this.getServletConfig().getServletContext(),
                    session);

            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            EndpointAdminClient client = new EndpointAdminClient(cookie, url, configContext);

            boolean error = false;
            String sourceModeEdit = null;
            sourceModeEdit = request.getParameter("epXML");
            String sub = null;
            StringBuilder ss = new StringBuilder();
            try{
            ss.append(getWDSLXML("anon".equals(session.getAttribute("epMode"))));
            }
            catch(Exception e){
            %>
               <script type="text/javascript">
    jQuery(document).ready(function(){
    function gotoPage(){
        //document.location.href='AddressEndpoint.jsp';
        history.go(-1);
    }
    CARBON.showErrorDialog('<%=e.getMessage()%>',gotoPage);
        });
</script>
            <%
                return;
            }
            if (sourceModeEdit != null && !"".equals(sourceModeEdit)) {
                OMElement elem = null;
                try {
                    elem = EndpointAdminClient.createOMFromString(sourceModeEdit);
                    OMAttribute nameAttr = elem.getAttribute(new QName("name"));
                    String epMode = null;
                    if ((epMode = (String)session.getAttribute("epMode")) != null && !"".equals(epMode) && "anon".equals(epMode)) {
                        // we are in the anon mode
                        if (nameAttr != null) {
                            elem.removeAttribute(nameAttr);
                        }
                        session.setAttribute("anonEpXML", elem.toString());
                    } else {
                        // we are in the normal mode
                        if (nameAttr != null) {
                            if (client.isEndpointExist(nameAttr.getAttributeValue())) {
                                try {
                                    client.saveEndpoint(elem.toString());
                                } catch (Exception e) {%>
                                    <script type="text/javascript">
                                        CARBON.showErrorDialog("Unable to save the endpoint");
                                        window.location.href="wsdlEndpoint.jsp";
                                    </script><%
                                    return;
                                }
                            } else {
                                 try {
                                     client.addEndpoint(elem.toString());
                                 } catch (Exception e) {%>
                                    <script type="text/javascript">
                                        CARBON.showErrorDialog("Unable to add the endpoint");
                                        window.location.href="wsdlEndpoint.jsp";
                                    </script><%
                                    return;
                                 }
                            }
                            sub = nameAttr.getAttributeValue();
                        }
                    }
                } catch (XMLStreamException e) {
                    // removes the anonymous endpoint XML if any
                    if (session.getAttribute("anonEpXML") != null) {
                        session.removeAttribute("anonEpXML");
                    }%>
                    <script type="text/javascript">
                        CARBON.showErrorDialog("Unable to parse the endpoint XML");
                        window.location.href="wsdlEndpoint.jsp";
                    </script><%
                    return;
                }
            } else {

                    // checks whether we are in anonymous endpoint mode
                    String epMode = (String)session.getAttribute("epMode");
                    if (epMode != null && !"".equals(epMode) && "anon".equals(epMode)) {
                        String forwardTo = (String) session.getAttribute("anonOriginator") + "?originator=wsdlEndpointCaller.jsp";
                        try {
                            EndpointAdminClient.getWsdlEndpointData(ss.toString());
                            session.setAttribute("anonEpXML", ss.toString());
                        } catch (Exception e) {
                            forwardTo = "wsdlEndpoint.jsp";%>
                            <script type="text/javascript">
                                CARBON.showErrorDialog("Unable to create endpoint with given data");
                            </script><%
                        }%>
                        <script type="text/javascript">
                            window.location.href="<%=forwardTo%>";
                        </script><%
                    } else {
                        EndpointMetaData[] epMetaData = client.getEndpointMetaData();
                        boolean exists = false;
                        if (epMetaData != null) {
                            for (EndpointMetaData data : epMetaData) {
                                if (data.getName().equalsIgnoreCase(name)) {
                                    exists = true;
                                    break;
                                }
                            }
                        }
                        if (exists && ((session.getAttribute("edit" + name)) != null)) {
                            try {
                                client.saveEndpoint(ss.toString());
                                session.removeAttribute("edit"+name);
                            }
                            catch (Exception e) {
                                session.removeAttribute("edit"+name);
                                error = true;
                                String errMsg = e.getMessage();
                                String dspMsg = errMsg.replaceAll("\\'","");
                                %>
        <script type="text/javascript">
            jQuery(document).ready(function(){
                                   function gotoWSDLPage(){
                        //  document.location.href='wsdlEndpoint.jsp';
                                       history.go(-1);
                      }
            CARBON.showErrorDialog('<%=dspMsg%>',gotoWSDLPage);
                    });
        </script>
        <%
                            }
                        } else {
                            try {
                                client.addEndpoint(ss.toString());
                            }
                            catch (Exception e) {
                                error = true;
                                String errMsg = e.getMessage();
                                String dspMsg = errMsg.replaceAll("\\'","");
                                %><script type="text/javascript">
            jQuery(document).ready(function(){
                      function gotoWSDLPage(){
                         // document.location.href='wsdlEndpoint.jsp';
                          history.go(-1);
                      }
            CARBON.showErrorDialog('<%=dspMsg%>',gotoWSDLPage);
                });

        </script>
        <%
                         }
                        }
                    }
            }%>
            <%if(sub!=null){%>
            <script type="text/javascript">
                forwardDesign('<%=sub%>');
            </script>
            <%}else{%>
            <%if(!error){%>
            <script type="text/javascript">
                forward();
            </script>
            <%}}%>
</div>
</fmt:bundle>
            <%--if (sourceModeEdit != null) {--%>
                <%--try {--%>
                    <%--client.addEndpoint(sourceModeEdit);--%>
                <%--}--%>
                <%--catch (Exception e) {--%>
                    <%--if (e.getMessage().indexOf("already") > 0) {--%>
                        <%--client.saveEndpoint(sourceModeEdit);--%>
                    <%--}--%>
                <%--}--%>
                <%--int start = sourceModeEdit.indexOf("name=");--%>
                <%--int end = sourceModeEdit.indexOf(">");--%>
                <%--sub = sourceModeEdit.substring(start + 6, end - 1);--%>
                <%--//PrintWriter oo = new PrintWriter(new PrintWriter(new File("/home/dinuka/Desktop/eeeee.txt")));--%>
                <%--//oo.println(sub);--%>
                <%--//oo.flush();--%>
                <%--//oo.close();--%>
                <%--//return;--%>
            <%--} else {--%>
                <%--StringBuilder ss = new StringBuilder();--%>
                <%--ss.append(getWDSLXML("anon".equals(session.getAttribute("epMode"))));--%>

                <%--// checks whether we are in anonymous endpoint mode--%>
                <%--String epMode = (String)session.getAttribute("epMode");--%>
                <%--if (epMode != null && "anon".equals(epMode)) {--%>
                    <%--String forwardTo = "../proxyservices/anonEpHandler.jsp";--%>
                    <%--try{--%>
                        <%--EndpointAdminClient.getWsdlEndpointData(ss.toString());--%>
                        <%--session.setAttribute("anonEpXML", ss.toString());--%>
                    <%--} catch (Exception e) {--%>
                        <%--forwardTo = "wsdlEndpoint.jsp";%>--%>
        <%--<script type="text/javascript">--%>
            <%--CARBON.showErrorDialog("Unable to create endpoint with given data");--%>
        <%--</script><%}%>--%>
        <%--<script type="text/javascript">--%>
            <%--window.location.href="<%=forwardTo%>";--%>
        <%--</script><%} else {--%>
                <%--EndpointMetaData[] epMetaData = client.getEndpointMetaData();--%>
                <%--boolean exists = false;--%>
                <%--if (epMetaData != null) {--%>
                    <%--for (EndpointMetaData data : epMetaData) {--%>
                        <%--if (data.getName().equalsIgnoreCase(name)) {--%>
                            <%--exists = true;--%>
                            <%--break;--%>
                        <%--}--%>
                    <%--}--%>
                <%--}--%>
                <%--if (exists && (((String) session.getAttribute("edit" + name)) != null)) {--%>
                    <%--try {--%>
                        <%--client.saveEndpoint(ss.toString());//stub.saveEndpoint(getWDSLXML());--%>
                    <%--}--%>
                    <%--catch (Exception e) {--%>
                        <%--error = 1;--%>
                 <%--%>--%>
        <%--<h3 style="color:red;"><%=e.getMessage()%></h3>--%>
        <%--<a href="javascript:history.go(-1)">Return to form </a>--%>
        <%--<%}}else{--%>
            <%--try{--%>
                <%--client.addEndpoint(ss.toString());//stub.addEndpoint(getWDSLXML());--%>
            <%--}--%>
            <%--catch(Exception e){--%>
                <%--error = 1;--%>
        <%--%>--%>
        <%--<h3 style="color:red;"><%=e.getMessage()%></h3>--%>
        <%--<a href="javascript:history.go(-1)">Return to form </a>--%>
        <%--<%}}}}%>--%>
        <%--<%if(sub!=null){%>--%>
        <%--<script type="text/javascript">--%>
            <%--forwardDesign('<%=sub%>');--%>
        <%--</script>--%>
        <%--<%}else{%>--%>
        <%--<%if (error==0){%>--%>
        <%--<script type="text/javascript">--%>
            <%--forward();--%>
        <%--</script>--%>
        <%--<%}}%>--%>
<%--</div>--%>