<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.mediators.ext.POJOCommandMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="java.util.*" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>


<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof POJOCommandMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    POJOCommandMediator pojoCommandMediator = (POJOCommandMediator) mediator;
    Map statsSetterPropeties = null;
    Map msgGetterProperties = null;
    Map msgSetterProperties = null;
    Map contextGetterProperties = null;
    Map contextSetterProperties = null;
    ArrayList<Map> mapList = new ArrayList<Map>();

    statsSetterPropeties = pojoCommandMediator.getStaticSetterProperties();
    msgGetterProperties = pojoCommandMediator.getMessageGetterProperties();
    msgSetterProperties = pojoCommandMediator.getMessageSetterProperties();
    contextGetterProperties = pojoCommandMediator.getContextGetterProperties();
    contextSetterProperties = pojoCommandMediator.getContextSetterProperties();
    mapList.add(statsSetterPropeties);
    mapList.add(msgSetterProperties);
    mapList.add(contextSetterProperties);

    String propertyTableStyle = (!statsSetterPropeties.isEmpty() || !msgSetterProperties.isEmpty() ||
            !contextSetterProperties.isEmpty()) ? "" : "display:none";

%>

<fmt:bundle basename="org.wso2.carbon.mediator.command.ui.i18n.Resources">
<carbon:jsi18n
            resourceBundle="org.wso2.carbon.mediator.command.ui.i18n.JSResources"
            request="<%=request%>"
            i18nObjectName="commandi18n"/>
<div>
<script type="text/javascript" src="../pojoCommand-mediator/js/mediator-util.js"></script>
<script type="text/javascript">
    var val;
    jQuery('#actionID').click(function() {
        val = document.getElementById('mediatorInputId').value;
        var url = '../pojoCommand-mediator/command-ajaxprocessor.jsp';
        jQuery('#attribDescription').load(url, {mediatorInput: val},
                function(res, status, t) {
                    if (status != "success") {
                        CARBON.showErrorDialog('<fmt:message key="mediator.command.errmsg"/>');
                    }
                })
        return false;
    });
</script>
<table class="normal" width="100%">
<tr>
    <td>
        <h2><fmt:message key="mediator.command.header"/></h2>
    </td>
</tr>
<tr>
    <td>
        <table class="normal">
            <tr>
                <td><fmt:message key="mediator.command.className"/><span class="required">*</span>
                </td>
                <td align="left"><input type="text" id="mediatorInputId" name="mediatorInput" size="35"
                                        value="<%= pojoCommandMediator.getCommand()!=null?pojoCommandMediator.getCommand().getName():""%>"/>&nbsp&nbsp&nbsp
                </td>
                <td><input id="actionID" type="button" value="<fmt:message key="mediator.command.loadClass"/>"
                           class="button"/>
                </td>
            </tr>
        </table>
    </td>
</tr>
<tr>
<td>
<div class="Mediator" id="attribDescription">
<h3 class="mediator" id="propertyLabel" style="<%=propertyTableStyle%>"><fmt:message
        key="mediator.command.properties"/></h3>
<table id="commandPropTable" style="<%=propertyTableStyle%>;" class="styledInner">
    <thead>
        <tr>
            <th width="10%"><fmt:message key="mediator.command.propName"/></th>
            <th width="10%"><fmt:message key="mediator.command.readInfo"/></th>
            <th width="10%"><fmt:message key="mediator.command.updateInfo"/></th>
            <th><fmt:message key="mediator.command.actions"/></th>
        </tr>
        <tbody>
            <%
                int i = 0;
                String inputName = null;
                String inputUpdateName = null;
                for (Map mapName : mapList) {
                    if (mapName != null) {
                        Set keys = mapName.keySet();
                        Object val = null;
                        Iterator keyItar = keys.iterator();
                        Set msgGetterKeySet = msgGetterProperties.keySet();
                        Set contextGetterKeySet = contextGetterProperties.keySet();
                        if (mapName.equals(statsSetterPropeties)) { //TODO: fix this may be we can't compare
                            inputName = "Value";
                        } else if (mapName.equals(msgSetterProperties)) {
                            inputName = "Expression";
                        } else if (mapName.equals(contextSetterProperties)) {
                            inputName = "Context name";
                        }
                        while (keyItar.hasNext()) {
                            Object key = keyItar.next();
                            if (msgGetterKeySet.contains(key)) {
                                val = msgGetterProperties.get(key); //returns a XPATH string
                                inputUpdateName = "Expression";
                            } else if (contextGetterKeySet.contains(key)) {
                                val = contextGetterProperties.get(key);
                                inputUpdateName = "Context name";
                            }
            %>
            <tr>
                <td rowspan="2"><input type="hidden" name="propertyName<%= i%>" id="propertyName<%= i%>"
                                       value="<%= key%>"/><%= key%>
                </td>
                <td><fmt:message key="mediator.command.from"/>:
                    <select id="propertySelectReadType<%= i%>" name="propertySelectReadType<%=i%>"
                            onchange="javascript:reloadFromChanges(this, <%= i%>)">
                        <option value="none">- <fmt:message key="mediator.command.selectValueNone"/> -
                        </option>
                        <option value="value" selected="true"><fmt:message
                                key="mediator.command.selectValueValue"/></option>
                        <option value="message"><fmt:message
                                key="mediator.command.selectValueMsg"/></option>
                        <option value="context"><fmt:message
                                key="mediator.command.selectValueContxt"/></option>
                    </select>
                </td>
                <td><fmt:message key="mediator.command.to"/>:
                    <select id="propertySelectUpdateType<%=i%>" name="propertySelectUpdateType<%=i%>"
                            onchange="  javascript:reloadToChanges(this,<%= i%>)">
                        <option value="none" selected="true">- <fmt:message
                                key="mediator.command.selectValueNone"/> -
                        </option>
                        <option value="message"><fmt:message
                                key="mediator.command.selectValueMsg"/></option>
                        <option value="context"><fmt:message
                                key="mediator.command.selectValueContxt"/></option>
                    </select>
                </td>
                <td><a href="#" class="icon-link" style="background-image:url(../admin/images/delete.gif);"
                       onclick="javascript:deleteRowCommand(this)"><fmt:message
                        key="mediator.command.delete"/></a></td>
            </tr>
            <tr>
                <td id="newReadInfoID<%=i%>"><%=inputName%>:<input type="text" value="<%=mapName.get(key)%>"
                                                                   name="readInfo<%=i%>"
                                                                   id="readInfo<%=i%>"></td>

                <td id="newUpdateInfoID<%=i%>">
                    <%
                        if (val != null) {
                    %>
                    <%=inputUpdateName%>:<input type="text" value="<%= val%>"
                                                name="updateInfo<%=i%>"
                                                id="updateInfo<%=i%>">
                    <%
                        }
                    %>
                </td>

            </tr>
            <%
                            i++;
                        }
                    }
                }
            %>
            <input type="hidden" name="propertyCount" id="propertyCount" value="<%=i%>"/>
        </tbody>
    </thead>
</table>
</div>
</td>
</tr>
</table>
</div>
</fmt:bundle> 