<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.config.xml.endpoints.EndpointSerializer" %>
<%@ page import="org.apache.synapse.endpoints.Endpoint" %>
<%@ page import="org.apache.synapse.endpoints.IndirectEndpoint" %>
<%@ page import="org.apache.synapse.mediators.builtin.SendMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.apache.synapse.endpoints.AbstractEndpoint" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof SendMediator)) {
        CarbonUIMessage.sendCarbonUIMessage("Unable to edit the mediator", CarbonUIMessage.ERROR, request);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
    SendMediator sendMediator = (SendMediator) mediator;

    // the varaibles holding which option of endpoints to be selected. If the endpoint is null then by default None
    String whichEP = "None";
    String anonEpXML = null;
    String  key = "";

    // The endpoint already associated with send mediator
    Endpoint endpoint = sendMediator.getEndpoint();  

    if (session.getAttribute("anonEpXML") != null) {
        whichEP = "Anon";
        anonEpXML = (String)session.getAttribute("anonEpXML");
    } else if (endpoint != null) {
        // if an endpoint has a name then it is an defined endpoint. So the option is Imp
        if (endpoint instanceof IndirectEndpoint) {
            if ((key = ((IndirectEndpoint)endpoint).getKey()) != null && !"".equals(key)) {
                whichEP = "Reg";
            } else {
                //TODO can an IndirectEndpoint be an anon endpoint ? do we need to remove the code below
                // no key, no name means it is an anonymous endpoint
                anonEpXML = EndpointSerializer.getElementFromEndpoint(endpoint).toString();
                if (anonEpXML != null && !"".equals(anonEpXML)) {
                     whichEP = "Anon";
                     session.setAttribute("anonEpXML", anonEpXML);
                }
            }
        } else if (endpoint instanceof AbstractEndpoint) {
            // no key, no name means it is an anonymous endpoint
            anonEpXML = EndpointSerializer.getElementFromEndpoint(endpoint).toString();
            if (anonEpXML != null && !"".equals(anonEpXML)) {
                whichEP = "Anon";
                session.setAttribute("anonEpXML", anonEpXML);
            } 
        }
    }
%>
    <script type="text/javascript">
        var whichEP = '<%=whichEP%>';

<%
  // Set the correct action for anonymous endpoint option
  if (anonEpXML != null && !"".equals(anonEpXML)) {
%>
        var epAction  = 'Edit';
<%
    } else {
%>
        var epAction  = 'Add';
<%
    }
%>
    </script>
<fmt:bundle basename="org.wso2.carbon.mediator.send.ui.i18n.Resources">
    <script type="text/javascript" src="../send-mediator/js/mediator-util.js"></script>

    <div>
        <table class="normal" width="100%">
            <tr>
                <td>
                    <h2><fmt:message key="send.mediator"/></h2>
                    <label><fmt:message key="select.endpoint.type"/></label>
                    <table id="epOptionTable">
                        <tr>
                            <td>
                                <input id="epOpNone" type="radio" name="epOp" value="none"
                                       onclick="hideEpOps();"/><fmt:message key="select.ep.none"/>
                            </td>
                        </tr>                                                        
                        <tr>
                            <td>
                                <input id="epOpAnon" type="radio" name="epOp" value="anon"
                                       onclick="showEpAddtionalOptions('epAnonAddEdit');"/><fmt:message key="anonymous"/>
                            </td>
                            <%
                                
                            %>
                            <% if( anonEpXML != null && !"".equals(anonEpXML)) { %>
                                <td>
                                    <a href="#" class="add-icon-link" id="epAnonAdd" onclick="anonEpAdd();"><fmt:message key="add"/></a>
                                </td>
                                <td>
                                    <a href="#" class="edit-icon-link" id="epAnonEdit" onclick="anonEpEdit();"  style="display:none;"><fmt:message key="edit"/></a>
                                </td>
                            <% } else { %>
                                <td>
                                    <a href="#" class="add-icon-link" id="epAnonAdd" onclick="anonEpAdd();" style="display:none;"><fmt:message key="add"/></a>
                                </td>
                                <td>
                                    <a href="#" class="edit-icon-link" id="epAnonEdit" onclick="anonEpEdit();"><fmt:message key="edit"/></a>
                                </td>
                            <% } %>
                                <td>
                                    <a href="#"  class="delete-icon-link" id="epAnonClear" onclick="anonEpClear();"><fmt:message key="clear"/></a>
                                </td>
                        </tr>
                        <tr>
                            <td>
                                <input id="epOpReg" type="radio" name="epOp" value="registry"
                                       onclick="showEpAddtionalOptions('registryEp');"/><fmt:message
                                    key="pick.from.registry"/>
                            </td>
                            <td>
                                <input type="text" id="registryKey" name="registryKey"
                                       value="<%=key%>" readonly="readonly"/>
                            </td>
                            <td>
                                <a href="#registryBrowserLink" id="regEpLink"
                                   class="registry-picker-icon-link"
                                   style="padding-left:40px"
                                   onclick="showInLinedRegistryBrowser('registryKey');"> Registry
                                    Browser</a>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <a name="registryBrowserLink"/>
        <div id="registryBrowser" style="display:none;"/>
    </div>
</fmt:bundle>