<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.mediators.base.SequenceMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof SequenceMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    SequenceMediator sequenceMediator = (SequenceMediator) mediator;
%>

<fmt:bundle basename="org.wso2.carbon.mediator.sequence.ui.i18n.Resources">
    <div>
        <script type="text/javascript" src="../sequence-mediator/js/mediator-util.js"></script>
        <script type="text/javascript" src="../resources/js/resource_util.js"></script>
        <table class="normal" width="100%">
            <tr>
                <td>
                    <h2><fmt:message key="mediator.sequence.header"/></h2>
                </td>
            </tr>

            <tr>
                <td>
                    <table class="normal">
                        <tr>
                            <td>
                                <fmt:message key="mediator.sequence.referring"/><span class="required">*</span>
                            </td>
                            <td>
                                <input class="longInput" type="text" value="<%= sequenceMediator.getKey() != null ? sequenceMediator.getKey() : "" %>"
                                        id="seq_ref" name="seq_ref" disabled="true"/>
                                <input type="hidden" value="<%= sequenceMediator.getKey() != null ? sequenceMediator.getKey() : "" %>"
                                        id="seq_ref_hidden" name="seq_ref_hidden"/>
                            </td>
                            <td>
                                <a href="#registryBrowserLink"
                                   class="registry-picker-icon-link"
                                   style="padding-left:40px"
                                   onclick="showInLinedRegistryBrowser('seq_ref')"><fmt:message
                                        key="mediator.sequence.registry.browser"/>
                                </a>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
        <div id="registryBrowser" style="display:none;"></div>
        <a name="registryBrowserLink"></a>
    </div>
</fmt:bundle>