<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.impl.llom.util.AXIOMUtil" %>
<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.wso2.carbon.mediator.throttle.ui.ThrottleMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="javax.xml.stream.XMLStreamException" %>
<%@ page import="java.util.Map" %>

<%
    try {
    String param = null;
    boolean isInline = false;
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof ThrottleMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    ThrottleMediator throttleMediator = (ThrottleMediator) mediator;

    param = request.getParameter("throttle_id1");
    if (param != null && !param.equals("")) {
        throttleMediator.setId(param);
    }
    throttleMediator.setPolicyKey(null);
    throttleMediator.setInLinePolicy(null);
    param = request.getParameter("policygroup");
    if (param != null && !param.equals("")) {
        if (param.equals("InLinePolicy")) {
            String policyID = SequenceEditorHelper.getEditingMediatorPosition(session) + "_throttle_policy";
            Map policyXMLMap = (Map) request.getSession().getAttribute("throttle_policy_map");
            if (policyXMLMap != null) {
                String policyXML = (String) policyXMLMap.get(policyID);
                if (policyXML != null && !"".equals(policyXML)) {
                    try {
                        OMElement ele = AXIOMUtil.stringToOM(policyXML);
                        throttleMediator.setInLinePolicy(ele);
                    } catch (XMLStreamException e) {
                        throw new RuntimeException("Invalid Policy File");
                    }
                }
            }
        } else if (param.equals("PolicyKey")) {
            String key = request.getParameter("mediator.throttle.regPolicy_hidden");
            if (key != null && !key.equals("")) {
                throttleMediator.setPolicyKey(key);
            }
        }
    }

    param = request.getParameter("onacceptgroup");
    if (param != null && !param.equals("")) {
        if (param.equals("onAcceptSequenceKey")) {
            String key = request.getParameter("mediator.throttle.accpetKey_hidden");
            throttleMediator.setOnAcceptSeqKey(key);
            throttleMediator.setAcceptMediatorPresent(false);
        } else if (param.equals("onAcceptSequence")) {
            throttleMediator.setAcceptMediatorPresent(true);
        }
    }

    param = request.getParameter("onrejectgroup");
    if (param != null && !param.equals("")) {
        if (param.equals("onRejectSequenceKey")) {
            String key = request.getParameter("mediator.throttle.rejectKey_hidden");
            throttleMediator.setOnRejectSeqKey(key);
            throttleMediator.setRejectMediatorPresent(false);
        } else if (param.equals("onRejectSequence")) {
            throttleMediator.setRejectMediatorPresent(true);
        }
    }

    } catch (Exception e) {
        session.setAttribute("sequence.error.message", e.getMessage());
%>
<script type="text/javascript">
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<%
    }
%>

<% if (SequenceEditorHelper.isRedirected(request)) { %>
<script type="text/javascript">
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<% } %>