/*
 *  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

function addKey(keyempty) {
    if (!isValidKey(keyempty)) {
        return false;
    }
    var keyCount = document.getElementById("keyCount");
    var i = keyCount.value;
    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    keyCount.value = currentCount;

    var keyTable = document.getElementById("keytable");
    keyTable.style.display = "";
    var keytbody = document.getElementById("keytbody");

    var keyRaw = document.createElement("tr");
    keyRaw.setAttribute("id", "keyRaw" + currentCount);

    var keyTD = document.createElement("td");
    keyTD.innerHTML = "Key<span class='required'>*</span>"; //TODO: i18n the Key

    var inputTD = document.createElement("td");
    inputTD.innerHTML = "<input class='longInput' type='text' id='key" + currentCount + "' name='key" + currentCount + "' value='' disabled='true'/>" +
                        "<input type='hidden' id='key" + currentCount + "_hidden' name='key" + currentCount + "_hidden' value=''/>";

    //TODO: i18n for Registry Key
    var registryID = document.createElement("td");
    registryID.innerHTML = "<a href='#registryBrowserLink'  class='registry-picker-icon-link' style='padding-left:40px' onclick=\"showInLinedRegistryBrowser('key" + currentCount + "')\">Registry Keys</a>";

    keyRaw.appendChild(keyTD);
    keyRaw.appendChild(inputTD);
    keyRaw.appendChild(registryID);

    keytbody.appendChild(keyRaw);
    return true;

}

function isValidKey(keyemptymsg) {
    var nsCount = document.getElementById("keyCount");
    var i = nsCount.value;
    var currentCount = parseInt(i);
    if (currentCount >= 0) {
        for (var k = 0; k <= currentCount; k++) {
            var prefix = document.getElementById("key" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(keyemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}

function addfeature(nameempty) {
    if (!isValidFeatures(nameempty)) {
        return false;
    }
    var featureCount = document.getElementById("featureCount");
    var i = featureCount.value;
    var currentCount = parseInt(i);
    currentCount = currentCount + 1;

    featureCount.value = currentCount;

    var featureTable = document.getElementById("featuretable");
    featureTable.style.display = "";
    var featuretbody = document.getElementById("featuretbody");

    var featureRaw = document.createElement("tr");
    featureRaw.setAttribute("id", "featureRaw" + i);

    var nameTD = document.createElement("td");
    nameTD.appendChild(createinputtextbox("featureName" + i), "");

    var deleteTD = document.createElement("td");
    deleteTD.innerHTML = "<a href='#' class='delete-icon-link' style='padding-left:40px' onclick='deletefeature(" + i + ");return false;'>Delete</a>";

    featureRaw.appendChild(nameTD);
    featureRaw.appendChild(deleteTD);

    featuretbody.appendChild(featureRaw);
    return true;
}

function createinputtextbox(id, value) {

    var input = document.createElement('input');
    input.setAttribute('id', id);
    input.name = id;
    input.setAttribute('type', 'text');
    if (value != null && value != undefined) {
        input.setAttribute('value', value);
    }

    return input;
}

function isValidFeatures(nameemptymsg) {

    var nsCount = document.getElementById("featureCount");
    var i = nsCount.value;

    var currentCount = parseInt(i);

    if (currentCount >= 1) {
        for (var k = 0; k < currentCount; k++) {
            var prefix = document.getElementById("featureName" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(nameemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}

function deletefeature(i) {
    var featureRow = document.getElementById("featureRaw" + i);
    if (featureRow != undefined && featureRow != null) {
        var parentTBody = featureRow.parentNode;
        if (parentTBody != undefined && parentTBody != null) {
            parentTBody.removeChild(featureRow);
            if (!isContainRaw(parentTBody)) {
                var featureTable = document.getElementById("featuretable");
                featureTable.style.display = "none";
            }
        }
    }
}

function isContainRaw(tbody) {
    if (tbody.childNodes == null || tbody.childNodes.length == 0) {
        return false;
    } else {
        for (var i = 0; i < tbody.childNodes.length; i++) {
            var child = tbody.childNodes[i];
            if (child != undefined && child != null) {
                if (child.nodeName == "tr" || child.nodeName == "TR") {
                    return true;
                }
            }
        }
    }
    return false;
}

function validateMediatorValidate() {
    var nameemptymsg = validate18n["mediator.validate.feature.name.empty"];
    var keyemptymsg = validate18n["mediator.validate.schema.key.empty"];
    
    var nsCount = document.getElementById("keyCount");
    var i = nsCount.value;
    currentCount = parseInt(i);
    if (currentCount >= 0) {
        for (var k = 0; k <= currentCount; k++) {
            var prefix = document.getElementById("key" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(keyemptymsg)
                    return false;
                }
            }
        }
    }

    nsCount = document.getElementById("featureCount");
    i = nsCount.value;
    currentCount = parseInt(i);
    if (currentCount >= 1) {
        for (k = 0; k < currentCount; k++) {
            prefix = document.getElementById("featureName" + k);
            if (prefix != null && prefix != undefined) {
                if (prefix.value == "") {
                    CARBON.showWarningDialog(nameemptymsg)
                    return false;
                }
            }
        }
    }
    return true;
}