<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.mediators.builtin.ValidateMediator" %>
<%@ page import="org.apache.synapse.mediators.MediatorProperty" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="java.util.*" %>
<%@ page import="org.apache.synapse.util.xpath.SynapseXPath" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.XPathFactory" %>
<%@ page import="org.xml.sax.SAXException" %>

<%
    Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
    if (!(mediator instanceof ValidateMediator)) {
        // todo : proper error handling
        throw new RuntimeException("Unable to edit the mediator");
    }
    ValidateMediator validateMediator = (ValidateMediator) mediator;

    // set keys
    List<String> schemaKeyList = new ArrayList<String>();
    String keyCountParameter = request.getParameter("keyCount");
    if (keyCountParameter != null && !"".equals(keyCountParameter)) {
        int keyCount = 0;
        try {
            keyCount = Integer.parseInt(keyCountParameter.trim());
        } catch (NumberFormatException e) {
            throw new RuntimeException("Invalid number format");
        }
        for (int i = 0; i <= keyCount; i++) {
            String keyValue = request.getParameter("key" + i + "_hidden");
            if (keyValue != null && !"".equals(keyValue)) {
                schemaKeyList.add(keyValue);
            }
        }
        validateMediator.setSchemaKeys(schemaKeyList);
    }

    // set source
    String sourceParameter = request.getParameter("mediator.validate.source");
    XPathFactory xPathFactory = XPathFactory.getInstance();
    if (sourceParameter != null && !"".equals(sourceParameter)) {
        validateMediator.setSource(xPathFactory.createSynapseXPath("mediator.validate.source", sourceParameter.trim(), session));
    }

    // set features
    String featureCountParameter = request.getParameter("featureCount");
    if (featureCountParameter != null && !"".equals(featureCountParameter)) {
        int featureCount = 0;
        try {
            featureCount = Integer.parseInt(featureCountParameter);
        } catch (NumberFormatException e) {
            throw new RuntimeException("Invalid number format");
        }
        // avoid duplications
        validateMediator.getFeatures().clear();
        for (int i = 0; i <= featureCount; i++) {
            String featureName = request.getParameter("featureName" + i);
            if (featureName != null && !"".equals(featureName)) {
                try {
                    validateMediator.addFeature(featureName, true); // TODO:always pass true ?
                } catch (SAXException e) {
//                    throw new RuntimeException("SAXException occurs,in valid feature",e);
                    //TODO; return an error to client saying an invalid feature
                    // see here: http://xerces.apache.org/xerces2-j/features.html
                    e.printStackTrace();
                }

            }
        }
    }

%>

<% if (SequenceEditorHelper.isRedirected(request)) { %>
<script type="text/javascript">
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<% } %>