<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.mediators.xquery.XQueryMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.apache.synapse.mediators.xquery.MediatorBaseVariable" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="org.wso2.carbon.mediator.xquery.internal.XQueryMediatorClientHelper" %>
<%@ page import="org.apache.synapse.mediators.xquery.MediatorCustomVariable" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.XPathFactory" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<%
    try {
        Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);

        if (!(mediator instanceof XQueryMediator)) {
            // todo : proper error handling
            throw new RuntimeException("Unable to edit the mediator");
        }
        XQueryMediator xqueryMediator = (XQueryMediator) mediator;
        String key = request.getParameter("mediator.xquery.key_hidden");
        if (key == null && "".equals(key)) {
            // todo : proper error handling
            throw new RuntimeException("XQuery script key cannot be null");
        }
        XPathFactory xPathFactory = XPathFactory.getInstance();
        xqueryMediator.setQueryKey(key.trim());
        String target = request.getParameter("mediator.xquery.target");
        if (target != null && !"".equals(target)) {
            xqueryMediator.setTarget(
                    xPathFactory.createSynapseXPath("mediator.xquery.target", target.trim(), session));
        }

        String variableCountParameter = request.getParameter("variableCount");
        if (variableCountParameter != null && !"".equals(variableCountParameter)) {
            int variableCount = 0;
            try {
                variableCount = Integer.parseInt(variableCountParameter.trim());
                xqueryMediator.reSetVariables();
                for (int i = 0; i < variableCount; i++) {
                    String name = request.getParameter("variableName" + i);
                    String type = request.getParameter("variableType" + i);

                    if (name != null && !"".equals(name) && type != null && !"".equals(type)) {
                        int typeValue = XQueryMediatorClientHelper.getType(type.trim());
                        if (typeValue == -1) {
                            continue;
                        }
                        String id = "variableValue" + i;
                        String value = request.getParameter(id);
                        String expression = request.getParameter("variableTypeSelection" + i);
                        boolean isExpression = expression != null && "expression".equals(expression.trim());
                        if (isExpression) {
                            MediatorCustomVariable variable = new MediatorCustomVariable((new QName(name.trim())));
                            variable.setType(typeValue);
                            if (value != null && !"".equals(value)) {
                                variable.setExpression(xPathFactory.createSynapseXPath(id, value.trim(), session));
                            }
                            String regKey = request.getParameter("registryKey_hidden" + i);
                            if (regKey != null && !"".equals(regKey)) {
                                variable.setRegKey(regKey.trim());
                            }
                            xqueryMediator.addVariable(variable);
                        } else {
                            if (value != null && !"".equals(value)) {
                                MediatorBaseVariable variable = new MediatorBaseVariable(new QName(name.trim()));
                                variable.setType(typeValue);
                                variable.setValue(value);
                                xqueryMediator.addVariable(variable);
                            }
                        }
                    }
                }
            } catch (NumberFormatException ignored) {
            }
        }
%>

<% if (SequenceEditorHelper.isRedirected(request)) { %>
<script type="text/javascript">
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<% } %>
<%
} catch (Exception e) {      

%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("An error has been occurred !. Error Message : " + '<%=e.getMessage()%>');
    });
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<%
        return;
    }
%>
