<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ page import="org.apache.synapse.Mediator" %>
<%@ page import="org.apache.synapse.mediators.transform.XSLTMediator" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.SequenceEditorHelper" %>
<%@ page import="org.apache.synapse.mediators.MediatorProperty" %>
<%@ page import="org.wso2.carbon.sequences.ui.util.ns.XPathFactory" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<%
    try {
       
        Mediator mediator = SequenceEditorHelper.getEditingMediator(request, session);
        if (!(mediator instanceof XSLTMediator)) {
            // todo : proper error handling
            throw new RuntimeException("Unable to edit the mediator");
        }
        XSLTMediator xsltMediator = (XSLTMediator) mediator;
        xsltMediator.setXsltKey(request.getParameter("mediator.xslt.key_hidden"));
        XPathFactory xPathFactory = XPathFactory.getInstance();
        xsltMediator.setSource(xPathFactory.createSynapseXPath("mediator.xslt.source",
                request.getParameter("mediator.xslt.source"), session));

        String propertyCountParameter = request.getParameter("propertyCount");
        if (propertyCountParameter != null && !"".equals(propertyCountParameter)) {
            int propertyCount = 0;
            try {
                propertyCount = Integer.parseInt(propertyCountParameter.trim());
                xsltMediator.reSetProperties();
                for (int i = 0; i <= propertyCount; i++) {
                    String name = request.getParameter("propertyName" + i);
                    if (name != null && !"".equals(name)) {
                        String valueId = "propertyValue" + i;
                        String value = request.getParameter(valueId);
                        String expression = request.getParameter("propertyTypeSelection" + i);
                        boolean isExpression = expression != null && "expression".equals(expression.trim());
                        MediatorProperty mp = new MediatorProperty();
                        mp.setName(name.trim());
                        if (value != null) {
                            if (isExpression) {
                                mp.setExpression(xPathFactory.createSynapseXPath(valueId, value.trim(), session));
                            } else if (value != null) {
                                mp.setValue(value.trim());
                            }
                        }
                        xsltMediator.addProperty(mp);
                    }
                }
            } catch (NumberFormatException ignored) {
            }
        }

        String featureCountParameter = request.getParameter("featureCount");
        if (featureCountParameter != null && !"".equals(featureCountParameter)) {
            int featureCount = 0;
            try {
                featureCount = Integer.parseInt(featureCountParameter.trim());
                xsltMediator.reSetFeatures();
                for (int i = 0; i <= featureCount; i++) {
                    String name = request.getParameter("featureName" + i);
                    if (name != null && !"".equals(name)) {
                        String value = request.getParameter("featureValue" + i);
                        if (value != null) {
                            xsltMediator.addFeature(name.trim(), Boolean.getBoolean(value.trim()));
                        }
                    }
                }
            } catch (NumberFormatException ignored) {
            }
        }
%>

<% if (SequenceEditorHelper.isRedirected(request)) { %>
<script type="text/javascript">
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<% } %>
<%
} catch (Exception e) {        
     %>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog("An error has been occurred !. Error Message : " + '<%=e.getMessage()%>');
    });
    document.location.href = "../sequences/design_sequence.jsp?ordinal=1";
</script>
<%
        return;
    }
%>
